#ifndef	__ARABIC_TEXT_ID_API_H__
#define __ARABIC_TEXT_ID_API_H__

#define	TYPE_TOTAL_CLASS    3

#define TYPE_PRINT_TEXT		1
#define TYPE_HANDWRITING	2
#define	TYPE_NOISE			3
#define	TYPE_OTHERS			4

#ifndef	WORD_ZONE_TYPE
#define	WORD_ZONE_TYPE
typedef struct {
//Bounding box of the word zone
  	int x;		
  	int y;
  	int w;
  	int h;
//Classification result
	int nType;
//Reserved
	int nIndex;
//Classification confidence for the first choice
	double	nConf;
//Classification confidence for all choices
	double	nClassConf[TYPE_TOTAL_CLASS];
}WORD_ZONE;
#endif

///////////////////////////////////////////////////////////////////////////////////////
class __declspec(dllexport) CArabicLayerSeparate {
private:
	WORD_ZONE	*m_pWord;		//Segmented words
	int			m_nWord;		//Number of words
	void*		Tree_Line_Short;		//Classification tree for short text lines (3 or 4 words)
	void*		Tree_Line_Long;		//Classification tree for long text lines (5 or more words)
	void*		Tree_Word_Size;	//Classification tree at word level using word size

public:
	CArabicLayerSeparate(void);
	~CArabicLayerSeparate(void);

public:
	//Set image from file for processing
	int TISetImage(char *fnImg);
	//Set image from memory for processing
	int TISetImage(BYTE *pImgData, int w, int h);
	//Set classifier
	int TISetClassifier( char *fnShortTextLineClassifier, 
						 char *fnLongTextLineClassifier,
						 char *fnWordClassifier);
	//Word segmentation
	int TIWordSegmentation( );
	//performing word classification
	int TIClassification( );

	//This function provides a way for users can use his/her own module to perform segmentation, classification of logo, figure, etc., and then fill information to the structure of WORD.
	int TISetWord(WORD_ZONE *pWord, int nWord);
	//Similar to the previous function, but the custom's result is stored in ZONE file.
	int TISetWord(char *fnCustom);

	//Get an array of segmented and classified word zones
	int TIGetWord(WORD_ZONE *&pWord, int &nWord );
	//Output result to ZONE file
	int TIOutputZone( char *fnZone );
	//Get layer
	int TIGetLayer( BYTE *&pImgData, int &w, int &h, int nType );
	//Save layer
	int TISaveLayer( char *fnLayerImg, int nType );
};

#endif //__ARABIC_TEXT_ID_API_H__