//////////////////////////////////////////////////////////////////////////
// File Name:		FormStructDef.h
// File Function:	1. Definitions for recognition cores
//					2. Definitions for DSCC
//					3. Definitions for form template
//					4. Definitions for form registeration transform
//
//				Developed by:Zheng Yefeng
//			(c)copyright to Tsinghua THOCR Lab, 2001
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////
#ifndef __STRUCTDEF_H__
#define __STRUCTDEF_H__

#include "Imageobj.h"

///////////////////////////////////////////////////////////////////////////////////
//	Definition for recognition cores
//////////////////////////////////////////////////////////////////////////////////
typedef struct LineValleyStruct
{
    int x ;//X coordinate
    int ys ;//Start position
    int ye ;//End position
	//For binary yvs=ys, yve=ye
    int yvs ;//Start position of valley
    int yve ;//End position of valley
    BYTE EdgeGray ;//Gray level of valley edge
    BYTE gray ;//gray level of bottom of valley?
} LineValley ;

typedef struct ConnComponentStruct
{
    int nInitialNode;//Initial runlength
	int nPixelsNum;//Number of black pixels
    RECT rcBound ;//Bounding box of connected component
} ConnComp ;

typedef struct ConnNodeStruc
{
    int nLtTotal ;//Total left connected runlength
    int pLeft ;//Left runlength
    int nRtTotal ;//Total right connected runlength
    int pRight ;//Right runlength
    int pUnder ;//Under ConnNode
    int pAbove ;//Above ConnNode
    LineValley v ;//Node information
} ConnNode ;

#endif // __STRUCTDEF_H__