////////////////////////////////////////////////////////////////////////////////////////////////
// File NAME:		GTMakerDoc.h
// File Function:	Interface of CGTMakerDoc class
//
//				Developed by: Yefeng Zheng
//			   First created: Jan, 2001
//			   Last modified: June, 2002
//			University of Maryland, College Park
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined __GTMAKER_DOC_H__
#define __GTMAKER_DOC_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include	"ImageObj.h"
#include	"define.h"

class CGTMakerDoc : public CDocument
{
protected: // create from serialization only
	CGTMakerDoc();
	DECLARE_DYNCREATE(CGTMakerDoc)

// Attributes
public:
	CImage		m_Img;			//Image
	ZONE		*zone;			//Zone segmentation results
	int			zone_count;		//Number of zones
	CString		m_csImgName;	//Image file name
	CString		m_csZoneName;	//Zone segmentation result file name
	int			m_nSelZone;		//Number of selected zones
	int			*m_nSelZoneIndex;	//Index of currently selected zone
	int			m_nSelCorner;	//Corner index of currently selected zone
	BOOL		m_bNeedSave;	//Need save or not
private:
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGTMakerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	int RemoveSmallZone();
	void SaveZoneType();
	void	FreeMem();
	virtual ~CGTMakerDoc();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// Generated message map functions
protected:
	//{{AFX_MSG(CGTMakerDoc)
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveas();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __GTMAKER_DOC_H__
