////////////////////////////////////////////////////////////////////////////////////////////////
// File NAME:		MainFrm.cpp
// File Function:	Implementation of CMainFrame class
//
//				Developed by: Yefeng Zheng
//			   First created: Jan, 2001
//			   Last modified: June, 2002
//			University of Maryland, College Park
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GTMaker.h"
#include "MainFrm.h"
#include "GTMakerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL	m_bCloseAll;		//Close all or not
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_XY,  
	ID_IMAGESIZE,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_bCloseAll = FALSE;	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndStatusBar.SetPaneInfo(1, ID_XY, SBPS_NORMAL, 100 );
	m_wndStatusBar.SetPaneInfo(2, ID_IMAGESIZE, SBPS_NORMAL, 100 );
	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

/************************************************************************************
/*	Name:		SetXY
/*	Function:	Display mouse position on the right bottom corner
/*	Parameter:	point -- Mouse position
/*	Return:		0 -- Succeed
/************************************************************************************/
int CMainFrame::SetXY(CPoint point)
{
	char XY[20];
	sprintf(XY,"Mouse:(%d, %d)",point.x, point.y);
	m_wndStatusBar.SetPaneText(1, XY, FALSE);
	m_wndStatusBar.Invalidate(FALSE);
	return 0;
}

/************************************************************************************
/*	Name:		SetImageSize
/*	Function:	Display image size information
/*	Parameter:	point -- Image size
/*	Return:		0 -- Succeed
/************************************************************************************/
int CMainFrame::SetImageSize(int nWidth, int nHeight)
{
	char csImageSize[20];
	sprintf(csImageSize,"Size:(%d, %d)", nWidth, nHeight );
	m_wndStatusBar.SetPaneText(2, csImageSize, FALSE);
	m_wndStatusBar.Invalidate(FALSE);
	return 0;
}
