////////////////////////////////////////////////////////////////////////////////////////////////
// File NAME:		GTMakerView.h
// File Function:	Interface of CGTMakerView class
//
//				Developed by: Yefeng Zheng
//			   First created: Jan, 2001
//			   Last modified: June, 2002
//			University of Maryland, College Park
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined __GTMAKER_VIEW_H__
#define __GTMAKER_VIEW_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GTMakerDoc.h"

class CGTMakerView : public CScrollView
{
protected: // create from serialization only
	CGTMakerView();
	DECLARE_DYNCREATE(CGTMakerView)

// Attributes
public:
	CGTMakerDoc* GetDocument();
	double	m_nRatio;		//Zoom ratio
	int		m_ViewStatus;	//View status
	CPoint	LastPoint;		//Last position of the mouse
	CPoint	CurrentPoint;	//Current position of the mouse
	CPoint	m_MousePos;		//Mouse position

// Operations
public:
	int	UpdateZoneTypeDisplay();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGTMakerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	int SelectZone( CPoint pt );
	int SelectZone( CPoint pt1, CPoint pt2 );
	int GetSelCorner( ZONE box, CPoint point );
	virtual ~CGTMakerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGTMakerView)
	afx_msg void OnZoomIn();
	afx_msg void OnZoomNormal();
	afx_msg void OnZoomOut();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnEditAddZone();
	afx_msg void OnUpdateEditAddZone(CCmdUI* pCmdUI);
	afx_msg void OnEditDeleteZone();
	afx_msg void OnUpdateEditDeleteZone(CCmdUI* pCmdUI);
	afx_msg void OnZoomFit();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnViewZoneConf();
	afx_msg void OnUpdateViewZoneConf(CCmdUI* pCmdUI);
	afx_msg void OnViewZone();
	afx_msg void OnUpdateViewZone(CCmdUI* pCmdUI);
	afx_msg void OnZoneHand();
	afx_msg void OnUpdateZoneHand(CCmdUI* pCmdUI);
	afx_msg void OnZoneNoise();
	afx_msg void OnUpdateZoneNoise(CCmdUI* pCmdUI);
	afx_msg void OnZonePrint();
	afx_msg void OnUpdateZonePrint(CCmdUI* pCmdUI);
	afx_msg void OnViewImage();
	afx_msg void OnUpdateViewImage(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in illumView.cpp
inline CGTMakerDoc* CGTMakerView::GetDocument()
   { return (CGTMakerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // __GTMAKER_VIEW_H__
