#include "stdafx.h"
#include "classtif.h"


CTiff::CTiff(const char *pszFileName,UINT nOpenFlags,int image_no,LPSTR szPath)
                                    : CImg(pszFileName,nOpenFlags)
{
    setdata(image_no,szPath);

#ifdef _Group4

    setstaticdata();

#endif

    memoryhandle=NULL;
}
        
        
CTiff::~CTiff()
{
#ifdef _Group4

    GlobalUnlock(static_data_handle);
    static_data_handle = GlobalFree(static_data_handle);

#endif
}


BOOL CTiff::openimagefile(char *filename,UINT nOpenFlags,int image_no,LPSTR szPath)
{
    if(!CImg::openimagefile(filename,nOpenFlags)) return FALSE;
    setdata(image_no,szPath);

#ifdef _Group4

    setstaticdata();
    if(errorflag == TRUE)   return FALSE;
    
#endif

    memoryhandle=NULL;
    return TRUE;
}
        
           
unsigned int CTiff::getword(void)
{
    WORD i;
    int m,n;
    
    Read((void*)(&i),2);
    m=(unsigned int)i&0x000000ff;
    n=((unsigned int)i&0x0000ff00) >> 8;
    if(flag==1) return((unsigned int)((n<<8)+m));
    else return ((unsigned int)((m<<8)+n));
}


unsigned long CTiff::getlong(void)
{
    long c;
    int m[4],i;
    unsigned long value;
    
    Read((void*)&c, 4);
    for(i=0;i<4;i++)
    {
        m[i] = (c >> (8 * i)) & 0x000000ff;
    }
    value=0;
    if(flag==1)
    {
        for(i=0;i<4;i++)
        {
            value <<= 8;
            value += m[3-i];
        }
    }
    else
    {
        for(i=0;i<4;i++)
        {
            value <<= 8;
            value += m[i];
        }
    }       
    return (value);
}

    
BOOL CTiff::writemyhead(HANDLE handle)
{
    MYHEAD myhead;
//    myhead.id[0] = 'C';
//    myhead.id[1] = 'L';
    myhead.option = imageinfor();
    myhead.option &= 0xfffffffc;
    myhead.option += (samperpixel & 0x00000003);
    myhead.metrics = imagemetrics();
    
    myhead.res_unit = resolutionunit;
    myhead.h_res0 = h_res0;
    myhead.h_res1 = h_res1;
    myhead.v_res0 = v_res0;
    myhead.v_res1 = v_res1;
    
    char* pointer;
    pointer = (char*)GlobalLock(handle);
    if(pointer == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        return FALSE;
    }
    
    memcpy((void*)pointer, (void*)&myhead, sizeof(MYHEAD));
    
    GlobalUnlock(handle);
    return TRUE;
}


BOOL CTiff::setdata(int image_no,LPSTR szPath)
{
    struct IFDfield
    {   
        unsigned int tagname;
        unsigned int tagtype;
        long fieldlength;
        long tagdataoffset;
    }tagdata;
    char temp[12];
    long pointer,TempPointer;
    unsigned int i,j,m,n;
    
    lstrcpy((LPSTR)filextension,(LPCSTR)"TIF");
    if(isvalidfile())
        valid = TRUE;
    else
        valid = FALSE ; 
    
    samperpixel = 1;                    // set default value
    bitpersample = 1;                   // set default value
    planar = 1;                         // set default value
    rowsperstrip = MAXNUMBER;           // set default value
    istiled = FALSE;                    // set default value
    photometric = 0;                    // no default value, but I have to...
    newsubfiletype = 0;                 // set default value
    compression = 1;                    // set default value
    resolutionunit = 2;                 // set default value
    Orientation = 1;                    // set default value
    T4Options = 0;                      // set default value
    FillOrder = 1;                      // set default value
    nPredictor = 1;                     // set default value
    h_res1 = 1;                         // no default value, but I have to...
    h_res0 = 300;                       // no default value, but I have to...
    v_res1 = 1;                         // no default value, but I have to...
    v_res0 = 300;                       // no default value, but I have to...
    XResolutionPos = YResolutionPos = 0;// no default value, but I have to...
    StripBytesPos = 0;                  // no default value, but I have to...
    
    width = height = 0;
    
    if(szPath != NULL)
        lstrcpy((LPSTR)szLibraryPath,(LPCSTR)szPath);
    else
        szLibraryPath[0] = '\0';

//  if(openflags & CFile::modeCreate) return TRUE;
//  new file created .
    
    pointer = GetLength();
    if(pointer == 0)    return TRUE;
    
//  if(openflags & 0x1001)      // Create or write mode .
//      return TRUE;

    if((Read((void*)temp,2))!=2)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error reading file .");
        return FALSE;
    }
    
    if(temp[0]=='I' && temp[1]=='I') flag = 1;
    else if(temp[0]=='M' && temp[1]=='M')   flag = 0;
    else
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"not valid tiff file .");
        return FALSE;
    }
    
    n = getword();
    if(n != 42)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"not valid tiff file . ");
        return FALSE;
    }
    
    pointer = getlong();
    if(pointer!=Seek(pointer,CFile::begin))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"file seek error .");
        return FALSE;
    }
    
    n = image_no - 1;
    while(n)
    {
        i = getword();
        Seek((long)i*12,CFile::current);
        pointer = getlong();
        if(pointer == 0)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"no more image in file .");
            return FALSE;
        }
        
        if(pointer != Seek(pointer,CFile::begin))
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"file seek error .");
            return FALSE;
        }
        
        n --;
    }
    
    n = getword();
    for(i=0;i<n;i++)
    {
        tagdata.tagname = getword();
        tagdata.tagtype = getword();
        tagdata.fieldlength = getlong();
        tagdata.tagdataoffset = getlong();

        switch(tagdata.tagname)
        {
            case 0x0100 :
                width = (unsigned int) tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        width = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        width = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x0101 :
                height = (unsigned int) tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        height = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        height = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x0115 :
                samperpixel = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        samperpixel = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        samperpixel = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                if((samperpixel != 1 && photometric != 2) ||
                   (samperpixel != 3 && photometric == 2))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"extra samples not support .");
                    return FALSE;
                }
                break;
            case 0x0102 :
                if(tagdata.fieldlength==1)
                {
                    if(flag == 1)
                        bitpersample = tagdata.tagdataoffset & 0x0000ffff;
                    else
                        bitpersample = (tagdata.tagdataoffset >> 16) & 0x0000ffff;
                }
                else
                {
                    TempPointer = GetPosition();
                    if(tagdata.tagdataoffset!=Seek(tagdata.tagdataoffset,
                            CFile::begin))
                    {
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,"file seek error .");
                        return FALSE;
                    }
                    j = getword();
                    bitpersample = j;
                    for(m=0;(int)m<samperpixel-1;m++)
                    if (j!=getword())
                    {
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,
                            "multi_bitspersample not supported .");
                        return FALSE;
                    }
                    if(TempPointer!=Seek(TempPointer,CFile::begin))
                    {
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,"file seek error .");
                        return FALSE;
                    }
                }
                break;
            case 0x0106 :
                photometric = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        photometric = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        photometric = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                if(photometric>=4)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,
                        "multi_image not supported .");
                    return FALSE;
                }
                break;
            case 0x010a :
                FillOrder = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        FillOrder = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        FillOrder = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
//              if(FillOrder == 2)
//              {
//                  errorflag = TRUE;
//                  lstrcpy((LPSTR)errormessage,"FillOrder is 2 not support .");
//                  return FALSE;
//              }
                break;
            case 0x0112 :
                Orientation = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        Orientation = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        Orientation = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                if(Orientation > 4)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"Orientation Value not supported .");
                    return FALSE;
                }
            case 0x011c :
                planar = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        planar = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        planar = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x0124 :
                T4Options = tagdata.tagdataoffset;
                if((tagdata.tagdataoffset & 0x0002) != 0)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"uncompressed mode not support .");
                    return FALSE;
                }
                break;
            case 0x0125 :
                if((tagdata.tagdataoffset & 0x0002) != 0)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"uncompressed mode not support .");
                    return FALSE;
                }
                break;
            case 0x0140 :
                ColorMapPos = tagdata.tagdataoffset;
                break;
            case 0x0116 :
                rowsperstrip = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        rowsperstrip = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        rowsperstrip = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x0111 :
                StripOffsetsPos = tagdata.tagdataoffset;
                typeofstripoff = tagdata.tagtype;
                break;
            case 0x0117 :
                StripBytesPos = tagdata.tagdataoffset;
                typeofstripbytes = tagdata.tagtype;
                break;
            case 0x0142 :
                tilewidth = (int)tagdata.tagdataoffset;
                istiled = TRUE;
                break;
            case 0x0143 :
                tilelength = (int)tagdata.tagdataoffset;
                tilexnum = (width + tilewidth - 1) / tilewidth;
                tileynum = (height + tilelength - 1) / tilelength;
                numoftile = tilexnum * tileynum;
                break;
            case 0x0144 :
                TileOffsetsPos = tagdata.tagdataoffset;
                break;
            case 0x0145 :
                TileBytesPos = tagdata.tagdataoffset;
                typeoftilebytes = tagdata.tagtype;
                break;
            case 0x0103 :
                if(flag == 1)
                    compression = tagdata.tagdataoffset & 0x0000ffff;
                else
                    compression = (tagdata.tagdataoffset >> 16) & 0x0000ffff;
                switch(compression)
                {
                    case 1 :
                        break;
                    case 4 :
                        compression = 3;
                        break;
                    case 2 :
                        compression = 8;
                        break;
                    case 3 :
                        compression = 9;
                        break;
                    case 5 :
                        compression = 2;
                        break;  
                    case 32773 :
                        compression = 4;
                        break;
                    default :
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,
                                "compression method not supported .");
                        return FALSE;
                }
                break;
            case 0x0128 :
                resolutionunit = (unsigned int) tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        resolutionunit = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        resolutionunit = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x011a :
                XResolutionPos = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        XResolutionPos = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        XResolutionPos = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x011b :
                YResolutionPos = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        YResolutionPos = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        YResolutionPos = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
                break;
            case 0x00fe :
                newsubfiletype = tagdata.tagdataoffset;
                if(tagdata.tagtype == 3)
                {
                    if(flag == 1)
                        newsubfiletype = tagdata.tagdataoffset & 0x0000ffffL;
                    else
                        newsubfiletype = (tagdata.tagdataoffset >> 16) & 0x0000ffffL;
                }
//              if(newsubfiletype!=0)
//              {
//                  errorflag = TRUE;
//                  lstrcpy((LPSTR)errormessage,
//                      "multi_image not supported .");
//                  return FALSE;
//              }
                break;
            case 0x13d :
                nPredictor = (short)tagdata.tagdataoffset;
                if(nPredictor != 1 && nPredictor != 2)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Differencing mode not supported.");
                    return FALSE;
                }
                break;
        }
    }

    if(image_no == 1 && getlong() != 0)
        IFDNumber = FALSE;
    else
        IFDNumber = TRUE;

    if(XResolutionPos != 0)
    {
        Seek(XResolutionPos,CFile::begin);
        h_res0 = getlong();
        h_res1 = getlong();
    }
    if(YResolutionPos != 0)
    {
        Seek(YResolutionPos,CFile::begin);
        v_res0 = getlong();
        v_res1 = getlong();
    }
    
    if(rowsperstrip==MAXNUMBER)
        numofstrip = 1;
    else
        numofstrip = (int)(((long)height+rowsperstrip-1L)/rowsperstrip);

    // code for some garbage tiff files.
    if(StripBytesPos == 0)
    {
        StripBytesPos = GetLength() - StripOffsetsPos;
    }
    
    depth = samperpixel * bitpersample;
    
    color = photometric ;

    if(color == 3)
    {
        Seek(ColorMapPos,CFile::begin);

        j = 1 << depth;
        for(m=0;m<3;m++)
        for(i=0;i<j;i++)
        {
            n = getword();
            n >>= 8;
            palette[i * 3 + m] = (unsigned char)n;
        }
    }
    
    if(FillOrder == 2)
    {
        if(depth != 1 || (compression != 1 && compression != 3 &&
                compression != 8 && compression != 9) || color >= 2)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"FillOrder error .");
            return FALSE;
        }
        
        for(i=0;i<256;i++)
        {
            cLookupTable[i] = '\0';
            for(j=0;j<8;j++)
                if(i & (1 << j))    cLookupTable[i] += 1 << (7 - j);
        }
    }

    if(nPredictor == 2 && (bitpersample > 8 || compression != 2))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage, "Difference not supported.");
        return FALSE;
    }

    return TRUE;
}


BOOL CTiff::getimage(unsigned char *pointer,DWORD fileoffset,
                    DWORD inbytes,int x,int y,long *usedbyte)
{
    if(errorflag) return(FALSE);
    
    HANDLE handle,handle01;
    unsigned char *memorypointer;
    DWORD li,lj;
    int i,j,k,m,n;
    
    if(color < 2)                       // non_colorful image
    {
        if(depth == 1)                  // bi_level image
        {
            if(compression == 1)        // no_compression
            {
                Seek(fileoffset,CFile::begin);
                
                i = (x + 7) / 8;
                lj = (long)i * y;
//              if(inbytes < lj)
//              {
//                  errorflag = TRUE;
//                  lstrcpy((LPSTR)errormessage,"inbytes error .");
//                  return FALSE;
//              }
                
                if(Read((void*)pointer,lj) != lj)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    return FALSE;
                }
                
                if(FillOrder == 2)
                {
                    for(li=0;li<lj;li++)
                        *(pointer+li) = cLookupTable[(int)*(pointer+li)];
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 9)   // Group3_compression
            {
                handle = GlobalAlloc(GMEM_MOVEABLE,inbytes + 10);
                if(handle == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error allocating memory .");
                    return FALSE;
                }
                
                memorypointer = (unsigned char*)GlobalLock(handle);
                if(memorypointer == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error locking memory .");
                    return FALSE;
                }
                
                i = (x + 7) / 8;
                li = (long)i * y;
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes + 10) < inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    GlobalUnlock(handle);
                    GlobalFree(handle);
                    return FALSE;
                }
// In fact , reading 10 bytes more than INBYTES ( which should be use under normal condition )
// is not a good way . But i really found some rubbish TIFF file that i have to support needing
// this operation .
                
                if(FillOrder == 2)
                {
                    for(lj=0;lj<inbytes;lj++)
                        *(memorypointer+lj)=cLookupTable[(int)*(memorypointer+lj)];
                }
                
                GlobalUnlock(handle);
                
                handle01 = grp3decomp(handle,inbytes,x,y);

                GlobalFree(handle);

                if(handle01 == NULL)    return FALSE;
                
                memorypointer = (unsigned char*)GlobalLock(handle01);
                if(memorypointer == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error locking memory .");
                    GlobalFree(handle01);
                    return FALSE;
                }
                
                memorypointer += sizeof(MYHEAD);
                memcpy(pointer, memorypointer, li);
                
                GlobalUnlock(handle01);
                GlobalFree(handle01);
                return TRUE;
            }
            else if(compression == 3)   // Group4_compression
            {
                handle = GlobalAlloc(GMEM_MOVEABLE,inbytes);
                if(handle == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error allocating memory .");
                    return FALSE;
                }
                
                memorypointer = (unsigned char*)GlobalLock(handle);
                if(memorypointer == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error locking memory .");
                    return FALSE;
                }
                
                i = (x + 7) / 8;
                li = (long)i * y;
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) != inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    GlobalUnlock(handle);
                    GlobalFree(handle);
                    return FALSE;
                }
                
                if(FillOrder == 2)
                {
                    for(lj=0;lj<inbytes;lj++)
                        *(memorypointer+lj)=cLookupTable[(int)*(memorypointer+lj)];
                }
                
                GlobalUnlock(handle);
                
                handle01 = grp4decomp(handle,inbytes,x,y);

                GlobalFree(handle);

                if(handle01 == NULL)    return FALSE;
                
                memorypointer = (unsigned char*)GlobalLock(handle01);
                if(memorypointer == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error locking memory .");
                    GlobalFree(handle01);
                    return FALSE;
                }
                
                memorypointer += sizeof(MYHEAD);
                memcpy(pointer, memorypointer, li);
                
                GlobalUnlock(handle01);
                GlobalFree(handle01);
                return TRUE;
            }
            else if(compression == 4)       // PackBits_compression
            {
                j = (x + 7) / 8;
                memorypointer = pointer;
                
                Seek(fileoffset,CFile::begin);
                
                for(i=0;i<y;i++)
                {
                    if(!readPackBitsline((unsigned char*)memorypointer,j))
                        return FALSE;
                    memorypointer += j;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 8)       // CCITT_1D_compression
            {
                handle = GlobalAlloc(GMEM_MOVEABLE,inbytes);
                if(handle == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error allocating memory .");
                    return FALSE;
                }
                
                memorypointer = (unsigned char*)GlobalLock(handle);
                if(memorypointer == NULL)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error locking memory .");
                    return FALSE;
                }
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) < 1)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    GlobalUnlock(handle);
                    GlobalFree(handle);
                    return FALSE;
                }
                
                if(FillOrder == 2)
                {
                    for(li=0;li<inbytes;li++)
                        *(memorypointer+li)=cLookupTable[(int)*(memorypointer+li)];
                }
                
                input_area = memorypointer;
                output_area = pointer;
                decomp_write_init_flag = 1;
                decomp_read_init_flag = 1;
                n = (x + 7) / 8;
                
                for(i=0;i<y;i++)
                {
                    li = 0;
                    m = 0;

                    do
                    {
                        k = 0;
                        j = 0;

                        do 
                        {
                            j = find_run_length_code(m);    
                            k += j;
                        } while (j > 63);
        
                        if(color == 0)
                            write_bits_d(k, m);
                        else
                            write_bits_d(k,!m);
                
                        li += k;
                        m = !m;
                    }while(li < (DWORD)x);
                    
                    if(n * 8 != x)
                    {
                        j = n * 8 - x;
                        write_bits_d(j,0);
                    }
                    read_bit(TRUE);
                }
                
                *usedbyte = l_v_f_r_l;
                GlobalUnlock(handle);
                GlobalFree(handle);
                return TRUE;
            }
            else if(compression == 2)       // LZW_compression
            {
                memorypointer = new unsigned char[inbytes];
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) != inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error reading file.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                if(!Read_LZW_Data(memorypointer, pointer, x))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error decode LZW data.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                delete []memorypointer;
                return TRUE;
            }
            
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"compression method not supported .");
            return FALSE;                       
        }
        else                                // grayscale image
        {
            if(compression == 1)        // no_compression
            {
                i = (x * depth + 7) / 8;
                li = (long)i * y;
                
                if(inbytes < li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"inbytes error .");
                    return FALSE;
                }
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)pointer,li) != li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    return FALSE;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 4)   // PackBits_compression
            {
                j = (x * depth + 7) / 8;
                memorypointer = pointer;
                
                Seek(fileoffset,CFile::begin);
                
                for(i=0;i<y;i++)
                {
                    if(!readPackBitsline((unsigned char*)memorypointer,j))
                        return FALSE;
                    memorypointer += j;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 2)       // LZW_compression
            {
                memorypointer = new unsigned char[inbytes];
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) != inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error reading file.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                if(!Read_LZW_Data(memorypointer, pointer, x))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error decode LZW data.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                delete []memorypointer;
                return TRUE;
            }
            
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"Compression method not supported.");
            return FALSE;
        }
    }
    else                                // colorful image
    {
        if(color == 2)                  // RGB color
        {
            if(compression == 1)        // no_compression
            {
                if(planar == 2)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"planar not support .");
                    return FALSE;
                }
                
                li = 3 * (long)x * y;
                
                if(inbytes < li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"inbytes error .");
                    return FALSE;
                }
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)pointer,li) != li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    return FALSE;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 4)   //PackBits_compression
            {
                j = x * 3;
                memorypointer = pointer;
                
                Seek(fileoffset,CFile::begin);
                
                for(i=0;i<y;i++)
                {
                    if(!readPackBitsline((unsigned char*)memorypointer,j))
                        return FALSE;
                    memorypointer += j;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 2)       // LZW_compression
            {
                memorypointer = new unsigned char[inbytes];
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) != inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error reading file.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                if(!Read_LZW_Data(memorypointer, pointer, x))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error decode LZW data.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                delete []memorypointer;
                return TRUE;
            }
            
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"compression method not fit .");
            return FALSE;
        }
        else                            // palette color
        {
            if(compression == 1)        // no_compression
            {
                i = (x * depth + 7) / 8;
                li = (long)i * y;
                
                if(inbytes < li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"inbytes error .");
                    return FALSE;
                }
                
                Seek(fileoffset,CFile::begin);
                if(Read((void*)pointer,li) != li)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error reading file .");
                    return FALSE;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 4)   //PackBits_compression
            {
                j = (x * depth + 7) / 8;
                memorypointer = pointer;
                
                Seek(fileoffset,CFile::begin);
                
                for(i=0;i<y;i++)
                {
                    if(!readPackBitsline((unsigned char*)memorypointer,j))
                        return FALSE;
                    memorypointer += j;
                }
                
                *usedbyte = 0;
                return TRUE;
            }
            else if(compression == 2)       // LZW_compression
            {
                memorypointer = new unsigned char[inbytes];
                Seek(fileoffset,CFile::begin);
                if(Read((void*)memorypointer,inbytes) != inbytes)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error reading file.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                if(!Read_LZW_Data(memorypointer, pointer, x))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage, "Error decode LZW data.");
                    delete []memorypointer;
                    return FALSE;
                }
                
                delete []memorypointer;
                return TRUE;
            }
            
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"compression method not supported.");
            return FALSE;
        }
    }
}


BOOL CTiff::Read_LZW_Data(unsigned char* pInput, unsigned char* pOutput, int iWidth)
{
    HANDLE stackhandle;
    unsigned char *firstcodestack,*lastcodestack;
    int *codestack;
    
    stackhandle = GlobalAlloc(GMEM_MOVEABLE,8192*sizeof(int));
    firstcodestack = (unsigned char*)GlobalLock(stackhandle);
    if(firstcodestack == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return FALSE;
    }
    lastcodestack = firstcodestack + 2048*sizeof(int);
    codestack = (int*)(lastcodestack + 2048*sizeof(int));
    int wordmasktable[16] = 
        {
            0x0000,0x0001,0x0003,0x0007,
            0x000f,0x001f,0x003f,0x007f,
            0x00ff,0x01ff,0x03ff,0x07ff,
            0x0fff,0x1fff,0x3fff,0x7fff
        };
    
    int bits,bits2,codesize,codesize2;
    int nextcode,thiscode,oldtoken,currentcode,oldcode;
    int bitsused,byte;
    int iIndex;
    unsigned char *u;
    
    byte = 0;
    bitsused = 0;
    
    bits = 8;
    bits2 = 256;
    nextcode = bits2 + 2;
    codesize = bits + 1;
    codesize2 = 1 << codesize;
    oldcode = oldtoken = -1;
    iIndex = 0;
    
    while(1)
    {
        thiscode = *(pInput + iIndex);
        currentcode = codesize + bitsused;
        
        iIndex++;
        thiscode <<= currentcode - 8;
        if(currentcode <= 16)
        {
            thiscode |= (*(pInput + iIndex)) >> (16 - currentcode);
            bitsused = currentcode - 8;
            if(bitsused == 8)
            {
                iIndex ++;
                bitsused = 0;
            }
        }
        else
        {
            thiscode |= ((*(pInput + iIndex)) << (currentcode - 16));
            iIndex ++;
            thiscode |= ((*(pInput + iIndex)) >> (24 - currentcode));
            bitsused = currentcode - 16;
            if(bitsused == 8)
            {
                iIndex ++;
                bitsused = 0;
            }
        }
        
        thiscode &= wordmasktable[codesize];
        currentcode = thiscode;
        
        if(thiscode == (bits2 + 1))     break;
        
        if(thiscode > nextcode)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"Error decode LZW data.");
            GlobalUnlock(stackhandle);
            GlobalFree(stackhandle);
            return FALSE;
        }
        
        if(thiscode == bits2)
        {
            nextcode = bits2 + 2;
            codesize = bits + 1;
            codesize2 = 1 << codesize;
            oldtoken = oldcode = -1;
            continue;
        }
        
        u = firstcodestack;
        
        if(thiscode == nextcode)
        {
            if(oldcode == -1)
            {
                errorflag = TRUE;
                lstrcpy((LPSTR)errormessage,"Error decode LZW data.");
                GlobalUnlock(stackhandle);
                GlobalFree(stackhandle);
                return FALSE;
            }
            
            *u++ = oldtoken;
            thiscode = oldcode;
        }
        
        while(thiscode >= bits2)
        {
            *u++ = lastcodestack[thiscode];
            thiscode = codestack[thiscode];
        }
        
        oldtoken = thiscode;
        
        do
        {
            *(pOutput + byte++) = thiscode;

            if(u <= firstcodestack)     break;
            u --;
            thiscode = *u;
        } while(1);
        
        if(nextcode < 4096 && oldcode != -1)
        {
            codestack[nextcode] = oldcode;
            lastcodestack[nextcode] = oldtoken;
            nextcode ++;
            if(nextcode >= (codesize2 - 1) && codesize < 12)
            {
                codesize ++;
                codesize2 = 1 << codesize;
            }
        }
        
        oldcode = currentcode;
    }

    // Difference mode.
    if(nPredictor == 2)
    {
        int BitMask[8] = {0x001, 0x002, 0x004, 0x008, 0x010, 0x020, 0x040, 0x080};
        BOOL bFlag;
        char cValue;

        switch(depth)
        {
            case 1:
                iIndex = 0;
                while(iIndex < byte)
                {
                    if(*(pOutput + iIndex) & BitMask[7])
                        bFlag = TRUE;
                    else
                        bFlag = FALSE;
                    for(bits = 6; bits >= 0; bits ++)
                    {
                        if(bFlag)
                            *(pOutput + iIndex) ^= BitMask[bits];

                        if(*(pOutput + iIndex) & BitMask[bits])
                            bFlag = TRUE;
                        else
                            bFlag = FALSE;
                    }

                    for(bits2 = 1; bits2 < (iWidth + 7) / 8; bits2 ++)
                    {
                        for(bits = 7; bits >= 0; bits ++)
                        {
                            if(bFlag)
                                *(pOutput + iIndex + bits2) ^= BitMask[bits];

                            if(*(pOutput + iIndex + bits2) & BitMask[bits])
                                bFlag = TRUE;
                            else
                                bFlag = FALSE;
                        }
                    }

                    iIndex += (iWidth + 7) / 8;
                }

                break;

            case 2:
                iIndex = 0;
                while(iIndex < byte)
                {
                    *(pOutput + iIndex) = (*(pOutput + iIndex) & 0xcf) |
                        ((*(pOutput + iIndex) + ((*(pOutput + iIndex) >> 2) & 0x30)) & 0x30);
                    *(pOutput + iIndex) = (*(pOutput + iIndex) & 0xf3) |
                        ((*(pOutput + iIndex) + ((*(pOutput + iIndex) >> 2) & 0x0c)) & 0x0c);
                    *(pOutput + iIndex) = (*(pOutput + iIndex) & 0xfc) |
                        ((*(pOutput + iIndex) + ((*(pOutput + iIndex) >> 2) & 0x03)) & 0x03);
                    cValue = (*(pOutput + iIndex) & 0x03) << 6;

                    for(bits2 = 1; bits2 < (iWidth * 2 + 7) / 8; bits2 ++)
                    {
                        *(pOutput + iIndex + bits2) = (*(pOutput + iIndex + bits2) & 0x3f) |
                            ((*(pOutput + iIndex + bits2) + cValue) & 0xc0);
                        *(pOutput + iIndex + bits2) = (*(pOutput + iIndex + bits2) & 0xcf) |
                            ((*(pOutput + iIndex + bits2) +
                            ((*(pOutput + iIndex + bits2) >> 2) & 0x30)) & 0x30);
                        *(pOutput + iIndex + bits2) = (*(pOutput + iIndex + bits2) & 0xf3) |
                            ((*(pOutput + iIndex + bits2) +
                            ((*(pOutput + iIndex + bits2) >> 2) & 0x0c)) & 0x0c);
                        *(pOutput + iIndex + bits2) = (*(pOutput + iIndex + bits2) & 0xfc) |
                            ((*(pOutput + iIndex + bits2) +
                            ((*(pOutput + iIndex + bits2) >> 2) & 0x03)) & 0x03);
                        cValue = (*(pOutput + iIndex + bits2) & 0x03) << 6;
                    }

                    iIndex += (iWidth * 2 + 7) / 8;
                }

                break;

            case 4:
                iIndex = 0;
                while(iIndex < byte)
                {
                    cValue = (*(pOutput + iIndex) >> 4) & 0x0f;
                    cValue = (*(pOutput + iIndex) + cValue) & 0x0f;
                    *(pOutput + iIndex) = (*(pOutput + iIndex) & 0xf0) | cValue;

                    for(bits2 = 1; bits2 < (iWidth * 4 + 7) / 8; bits2 ++)
                    {
                        cValue = (*(pOutput + iIndex + bits2) + (cValue << 4)) & 0xf0;
                        *(pOutput + iIndex + bits2) = 
                            (*(pOutput + iIndex + bits2) & 0x0f) | cValue;
                        cValue = (cValue >> 4) & 0x0f;
                        cValue = (*(pOutput + iIndex + bits2) + cValue) & 0x0f;
                        *(pOutput + iIndex + bits2) =
                            (*(pOutput + iIndex + bits2) & 0xf0) | cValue;
                    }

                    iIndex += (iWidth * 4 + 7) / 8;
                }

                break;

            case 8:
                iIndex = 0;
                while(iIndex < byte)
                {
                    for(bits2 = 1; bits2 < iWidth; bits2 ++)
                    {
                        *(pOutput + iIndex + bits2) += *(pOutput + iIndex + bits2 - 1);
                    }

                    iIndex += iWidth;
                }

                break;

            case 24:
                iIndex = 0;
                while(iIndex < byte)
                {
                    for(bits2 = 3; bits2 < iWidth * 3; bits2 ++)
                    {
                        *(pOutput + iIndex + bits2) += *(pOutput + iIndex + bits2 - 3);
                    }

                    iIndex += iWidth * 3;
                }

                break;

            default:
                errorflag = TRUE;
                lstrcpy((LPSTR)errormessage, "BitsPerPixel not supported.");
                ::GlobalUnlock(stackhandle);
                ::GlobalFree(stackhandle);
                return FALSE;
        }
    }

    GlobalUnlock(stackhandle);
    GlobalFree(stackhandle);
    
    return TRUE;
}


HANDLE CTiff::readimage(void)
{
    if(errorflag) return(NULL);
    
    if(filehandle == CFile::hFileNull)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"no file opened .");
        return (NULL);
    }
    else if(openflags & 0x00001001)     // Create or write mode .
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"file reading not allowed .");
        return (NULL);
    }
    
    int bytesperline,tilebytesperline;
    long memorylength;
    unsigned char * pointer;
    unsigned char * temppointer;
    HANDLE temphandle;
    int xbytes,ybytes;
    int i,j,k,l;
    DWORD fileoffset,inbytes;
    
    j = 3;
    j <<= depth;
    if(color != 3)  j = 0;
    
    bytesperline = (width * depth + 7) / 8;
    
    memorylength = (long)height * bytesperline + sizeof(MYHEAD) + j;
    if(memoryhandle != NULL)    GlobalFree(memoryhandle);
    memoryhandle = GlobalAlloc(GMEM_MOVEABLE,memorylength);
    if(memoryhandle == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return (NULL);
    }
    
    if(!writemyhead(memoryhandle))  return (NULL);
    
    pointer = (unsigned char*)GlobalLock(memoryhandle);
    if(pointer == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        memoryhandle = GlobalFree(memoryhandle);
        return (NULL);
    }
    pointer += sizeof(MYHEAD);
    
    if(istiled)                     // tiled image process
    {
        memorylength = tilewidth * depth / 8 * (long)tilelength;
        temphandle = GlobalAlloc(GMEM_MOVEABLE,memorylength);
        if(temphandle == NULL)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error allocating memory .");
            GlobalUnlock(memoryhandle);
            memoryhandle = GlobalFree(memoryhandle);
            return (NULL);
        }
        
        temppointer = (unsigned char*)GlobalLock(temphandle);
        if(temppointer == NULL)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error locking memory .");
            GlobalFree(temphandle);
            GlobalUnlock(memoryhandle);
            memoryhandle = GlobalFree(memoryhandle);
            return (NULL);
        }
        
        tilebytesperline = tilewidth * depth / 8;
        for(i=0;i<tileynum;i++)
        for(j=0;j<tilexnum;j++)
        {
            if(numoftile == 1)
            {
                fileoffset = TileOffsetsPos;
                inbytes = TileBytesPos;
                if(typeoftilebytes == 3)    inbytes &= 0x0000ffffl;
            }
            else
            {
                Seek(TileOffsetsPos,CFile::begin);
                for(k=0;k<i*tilexnum+j+1;k++)
                    fileoffset = getlong();
                
                Seek(TileBytesPos,CFile::begin);
                for(k=0;k<i*tilexnum+j+1;k++)
                {
                    if(typeoftilebytes == 3)
                        inbytes = getword();
                    else
                        inbytes = getlong();
                }
            }
            
            if(!getimage(temppointer,fileoffset,inbytes,tilewidth,tilelength,&memorylength))
            {
                GlobalUnlock(memoryhandle);
                memoryhandle = GlobalFree(memoryhandle);
                GlobalUnlock(temphandle);
                GlobalFree(temphandle);
                
                return (NULL);
            }
            
            memorylength = (long)bytesperline * i * tilelength;
            memorylength += j * tilewidth * depth / 8;

            if(i < tileynum - 1)
                ybytes = tilelength;
            else
                ybytes = height - tilelength * i;

            if(j < tilexnum - 1)
                xbytes = tilebytesperline;
            else
                xbytes = bytesperline - tilebytesperline * j;
            
            for(k=0;k<ybytes;k++)
            {
                for(l=0;l<xbytes;l++)
                    *(pointer + memorylength + l) = *(temppointer +
                        k * tilebytesperline + l);
                
                memorylength += bytesperline;
            }
        }
        
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        
        if(color == 3)
        {
            pointer += (long)bytesperline * height;
            Seek(ColorMapPos,CFile::begin);
            
            j = 1 << depth;
            for(l=0;l<3;l++)
            for(i=0;i<j;i++)
            {
                k = getword();
                k >>= 8;
                *(pointer + i * 3 + l) = (unsigned char)k;
            }
        }
    }
    else                            // strip image process
    {
        for(i=0;i<numofstrip;i++)
        {
            if(numofstrip == 1)
            {
                fileoffset = StripOffsetsPos;
                inbytes = StripBytesPos;
                if(typeofstripoff == 3)     fileoffset &= 0x0000ffffl;
                if(typeofstripbytes == 3)   inbytes &= 0x0000ffffl;
                j = height;
            }
            else
            {
                Seek(StripOffsetsPos + i * 2 * (1 + (typeofstripoff == 4)),CFile::begin);
                if(typeofstripoff == 4)
                    fileoffset = getlong();
                else
                    fileoffset = getword();
                
                Seek(StripBytesPos + i * 2 * (1 + (typeofstripbytes == 4)),CFile::begin);
                if(typeofstripbytes == 4)
                    inbytes = getlong();
                else
                    inbytes = getword();
                
                if(i == numofstrip - 1)
                    j = height - (int)rowsperstrip * (numofstrip - 1);
                else
                    j = (int)rowsperstrip;
            }
            
            if(!getimage(pointer,fileoffset,inbytes,width,j,&memorylength))
            {
                GlobalUnlock(memoryhandle);
                memoryhandle = GlobalFree(memoryhandle);
                return (NULL);
            }
            
            pointer += (long)j * bytesperline;
        }
        
        if(color == 3)
        {
            Seek(ColorMapPos,CFile::begin);
            
            j = 1 << depth;
            for(l=0;l<3;l++)
            for(i=0;i<j;i++)
            {
                k = getword();
                k >>= 8;
                *(pointer + i * 3 + l) = (unsigned char)k;
            }
        }
    }
    
    GlobalUnlock(memoryhandle);
    
    char TableForOrientation[256],cTempForExchange;
    
    if(Orientation != 1)
    {
        pointer = (unsigned char*)GlobalLock(memoryhandle);
        if(pointer == NULL)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error locking memory .");
            GlobalFree(memoryhandle);
            return (NULL);
        }
        pointer += sizeof(MYHEAD);
        
        if(Orientation == 2 || Orientation == 3)    // left <--> right
        {
            for(i=0;i<256;i++)
            {
                TableForOrientation[i] = '\0';
                for(j=0;j<8;j++)
                {
                    if(i & (1 << j))    TableForOrientation[i] += 1 << (7 - j);
                }
            }
            
            bytesperline = (width + 7) / 8;
            l = bytesperline >> 1;
            memorylength = 0;
            
            for(i=0;i<height;i++)
            {
                for(j=0;j<l;j++)
                {
                    cTempForExchange = *(pointer + memorylength + j);
                    *(pointer + memorylength + j) =
                        *(pointer + memorylength + bytesperline - j - 1);
                    *(pointer + memorylength + bytesperline - j - 1) =
                        cTempForExchange;
                }
                
                for(j=0;j<bytesperline;j++)
                    *(pointer + memorylength + j) = TableForOrientation[(int)
                        (*(pointer + memorylength + j))];
                
                memorylength += bytesperline;
            }
        }
        
        if(Orientation == 3 || Orientation == 4)    // top <--> bottom
        {
            bytesperline = (width + 7) / 8;
            memorylength = 0;
            fileoffset = (long)(height - 1) * bytesperline;
            
            for(i=0;i<height/2;i++)
            {
                for(j=0;j<bytesperline;j++)
                {
                    cTempForExchange = *(pointer + memorylength + j);
                    *(pointer + memorylength + j) =
                        *(pointer + fileoffset + j);
                    *(pointer + fileoffset + j) = cTempForExchange;
                }
                
                memorylength += bytesperline;
                fileoffset -= bytesperline;
            }
        }
        
        GlobalUnlock(memoryhandle);
    }
    
    return (memoryhandle);
}


HANDLE CTiff::readimage(int x,int y,int xlength,int ylength)
{
    if(errorflag) return(NULL);
    
    if(filehandle == CFile::hFileNull)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"no file opened .");
        return (NULL);
    }
    else if(openflags & 0x00001001)     // Create or write mode .
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"file reading not allowed .");
        return (NULL);
    }

    if(istiled)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"tiled image not support such read .");
        return (NULL);
    }
    
    if(x + xlength > width || y + ylength > height)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"image not so large .");
        return (NULL);
    }
    
    HANDLE handle,temphandle;
    unsigned char* lpdata;
    unsigned char* lptempdata;
    long memlength;
    int linenumber,linereadbytes,bytesperline,i,j,k;
    
    if(color != 3)
        i = 0;
    else
        i = 3 << depth;
    
    memlength = ylength * (long)((xlength * depth + 7) / 8) + sizeof(MYHEAD) + i;
    handle = GlobalAlloc(GMEM_MOVEABLE , memlength);
    if(handle == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"memory allocation error .");
        return(NULL);
    }
    
    if(!writemyhead(handle))    return (NULL);
    
    lpdata = (unsigned char*)GlobalLock(handle);
    if(lpdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error occurs when locking memory .");
        GlobalFree(handle);
        return (NULL);
    }
    long metrics;
    metrics = (long)ylength << 16;
    metrics += xlength;
    for(i = 4;i < 8;i++)
        *(lpdata + i) = *((char*)&metrics + i - 4);
    
    lpdata += sizeof(MYHEAD);
    
    bytesperline = (width * depth + 7) / 8;
    linereadbytes = (xlength * depth + 7) / 8;

    if((temphandle = GlobalAlloc(GMEM_MOVEABLE , (bytesperline + 1)))==NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"memory allocation error .");
        GlobalUnlock(handle);
        GlobalFree(handle);
        return (NULL);
    }
    if((lptempdata = (unsigned char*)GlobalLock(temphandle)) == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error occurs when locking memory .");
        GlobalUnlock(handle);
        GlobalFree(handle);
        GlobalFree(temphandle);
        return (NULL);
    }
        
    k = x * depth - (int)(x * depth / 8) * 8;
    for(i=0;i<y+ylength;i++)
    {
        if(!readline((unsigned char*)lptempdata,&linenumber))
        {
            GlobalUnlock(temphandle);
            GlobalFree(temphandle);
            GlobalUnlock(handle);
            GlobalFree(handle);
            resetimagepointer();
            return (NULL);
        }
        
        if(linenumber >= y && linenumber < y + ylength)
        {
            for(j=0;j<linereadbytes;j++)
            {
                *(lpdata+j) = (char)(((*(lptempdata+(int)(x*depth/8)+j))<<k)+
                (char)(((unsigned char)(*(lptempdata+(int)(x*depth/8)+j+1)))>>(8-k)));
            }
            lpdata += linereadbytes;
        }
    }

    int l;
    if(color == 3)
    {
        Seek(ColorMapPos,CFile::begin);

        j = 1 << depth;
        for(l=0;l<3;l++)
        for(i=0;i<j;i++)
        {
            k = getword();
            k >>= 8;
            *(lpdata + i * 3 + l) = (unsigned char)k;
        }
    }

    resetimagepointer();
    GlobalUnlock(temphandle);
    GlobalFree(temphandle);
    GlobalUnlock(handle);
    return(handle);
}


// ע, GIF. һӸλʼ, һӵλʼ.
void CTiff::write_code(int code)  // Used for LZW compression.
{
    long temp;
    int byte_offset,bits_left;
    
    byte_offset = bit_offset >> 3;
    bits_left = bit_offset & 0x00000007;
    
    if(byte_offset >= 254)
    {
        Write((void*)code_buffer,byte_offset);
        
        code_buffer[0] = code_buffer[byte_offset];
        bit_offset = bits_left;
        byte_offset = 0;
    }
    
    if(bits_left > 0)
    {
        temp = ((long)code << (24 - bits_left - code_size));
        code_buffer[byte_offset + 0] = (unsigned char)(temp >> 16) | code_buffer[byte_offset];
        code_buffer[byte_offset + 1] = (unsigned char)(temp >> 8);
        code_buffer[byte_offset + 2] = (unsigned char)(temp);
    }
    else
    {
        code_buffer[byte_offset + 0] = (unsigned char)(code >> (code_size-8));
        code_buffer[byte_offset + 1] = (unsigned char)(code << (16 - code_size));
    }
    
    bit_offset += code_size;
    
    return;
}


BOOL CTiff::readPackBitsline(unsigned char *pointer,int x)
{
    int c,i,j,n,index;
    HANDLE handle;
    unsigned char *pdata;
    long position;
    
    handle = GlobalAlloc(GMEM_MOVEABLE,x*2);
    pdata = (unsigned char*)GlobalLock(handle);
    if(pdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return FALSE;
    }
    
    position = GetPosition();
    index = 0;
    Read((void*)pdata,2*x);
    
    n = 0;
    do
    {
        c = *(pdata + index++);
        c = c & 0x000000ff;
        if(c & 0x00000080)
        {
            if(c != 0x00000080)
            {
                i = ((~c) & 0x000000ff) + 2;
                c = *(pdata + index++);
                
                while(i--)  *(pointer + n++) = c;
            }
        }
        else
        {
            i = c + 1;
            for(j=0;j<i;j++)
                *(pointer + n + j) = *(pdata + index++);
            
            n += i;
        }
        
    } while(n < x);
    
    position += index;
    Seek(position,CFile::begin);
    GlobalUnlock(handle);
    GlobalFree(handle);
    return TRUE;
}


BOOL CTiff::writePackBitsline(unsigned char *pointer,int x)
{
    char buffer[130],c;         // 128 should be enough .
    int index,i,t;
    HANDLE handle;
    unsigned char *pdata;
    int number,j;
    
    handle = GlobalAlloc(GMEM_MOVEABLE,x*2);
    pdata = (unsigned char*)GlobalLock(handle);
    if(pdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return FALSE;
    }
    
    index = i = t = number = 0;
    do
    {
        i = 0;
        while(((t + i) < (x - 1)) && (i < 125) && 
            (*(pointer + t + i) == *(pointer + t + i + 1))) i ++;
        if(i > 0)
        {
            if(index)
            {
                c = (char)((index - 1) & 0x0000007f);
                *(pdata + number++) = c;
                for(j=0;j<index;j++)
                    *(pdata + number++) = *(buffer + j);
                index = 0;
            }
            
            c = (char)((~i + 1) & 0x000000ff);
            *(pdata + number++) = c;
            *(pdata + number++) = *(pointer + t + i);
            t += i + 1;
        }
        else
        {
            buffer[index ++] = *(pointer + t ++);
            if(index > 126)
            {
                c = (char)((index - 1) & 0x0000007f);
                *(pdata + number++) = c;
                for(j=0;j<index;j++)
                    *(pdata + number++) = *(buffer + j);
                index = 0;
            }
        }
        
    } while(t < x);
    
    if(index)
    {
        c = (char)((index - 1) & 0x0000007f);
        *(pdata + number++) = c;
        for(j=0;j<index;j++)
            *(pdata + number++) = *(buffer + j);
        index = 0;
    }
    
    Write((void*)pdata,number);
    GlobalUnlock(handle);
    GlobalFree(handle);
    return TRUE;
}


BOOL CTiff::readline(unsigned char* buffer,int *index)
{
    long filepointer,used;
    int k,inbytes;
    
    if(errorflag) return FALSE;

    if(dataposition == 0)
    {

    if(filehandle == CFile::hFileNull)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"no file opened .");
        return FALSE;
    }
    else if(openflags & 0x00001001)     // Create or write mode .
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"file reading not allowed .");
        return FALSE;
    }

    if(istiled)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"tiled image not support line reading .");
        return FALSE;
    }
    
    if(compression != 1 && compression != 4 && compression != 8)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"Compression method not support line reading .");
        return FALSE;
    }
    
    }
    
    filepointer = GetPosition();
    if(filepointer != dataposition && dataposition != 0)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"file pointer changed .");
        return FALSE;
    }
    
    if(linenumber >= height)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"no more line in image .");
        return FALSE;
    }
    
    if(numofstrip == 1)
    {
        if(linenumber == 0)
        {
            filepointer = StripOffsetsPos;
        }
    }
    else
    {
        k = linenumber / (int)rowsperstrip;
        if(linenumber == k * (int)rowsperstrip)
        {
            Seek(StripOffsetsPos + k * 2 * (1 + (typeofstripoff != 3)),CFile::begin);
                if(typeofstripoff == 3)
                    filepointer = getword();
                else
                    filepointer = getlong();
        }
    }
    
    inbytes = (width * depth + 7) / 8 * 10;
    if(!getimage((unsigned char*)buffer,filepointer,inbytes,width,1,&used))
        return FALSE;
    
    *index = linenumber ++;
    if(used != 0)
        Seek((filepointer + used),CFile::begin);
    dataposition = GetPosition();
    
    return TRUE;
}


BOOL CTiff::writeimage(long metrics,int option,HANDLE handle)
{
    if(errorflag) return FALSE;
    
    if(filehandle == CFile::hFileNull)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"no file opened .");
        return FALSE;
    }

    if(!(openflags & 0x00001003))           // if file can be written
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"File writing not allowed .");
        return FALSE;
    }
    
    HANDLE temphandle;
    MYHEAD myhead;
    unsigned char* pointer;
    int i,bytesperline;
    long longvalue,ll,j,k;

#ifdef MultiImageWriting
    CFileStatus tiffFileStatus;
    DWORD lFileSeekBase;

    if(!GetStatus(tiffFileStatus))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error get file status.");
        return FALSE;
    }

    if(tiffFileStatus.m_size == 0)
    {
        lFileSeekBase = 8;
    }
    else
    {
        if(flag == 0)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"write multi-image in MM_TIFF file not supported.");
            return FALSE;
        }
        if(Seek(4,CFile::begin) != 4)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error seek file.");
            return FALSE;
        }
        lFileSeekBase = getlong();
        while(lFileSeekBase != 0)
        {
            if(Seek(lFileSeekBase,CFile::begin) != (LONG)lFileSeekBase)
            {
                errorflag = TRUE;
                lstrcpy((LPSTR)errormessage,"error seek file.");
                return FALSE;
            }
            lFileSeekBase = getword();
            lFileSeekBase *= 12;
            Seek(lFileSeekBase,CFile::current);
            lFileSeekBase = getlong();
        }
        Seek(-4,CFile::current);
        lFileSeekBase = tiffFileStatus.m_size;
        Write(&lFileSeekBase,4);
    }

#endif

    pointer = (unsigned char*)GlobalLock(handle);
    if(pointer == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        return FALSE;
    }
    
    for(i=0;i<sizeof(MYHEAD);i++)
        *((char *)&myhead + i) = *(pointer + i);
    
/*    if(myhead.id[0] != 'C' || myhead.id[1] != 'L')
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error data format .");
        GlobalUnlock(handle);
		GlobalFree(handle);
        return FALSE;
    }
    else 
*/	if((myhead.option & 0x000000fc) != (option & 0x000000fc))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"bits per pixel not fit .");
        GlobalUnlock(handle);
		GlobalFree(handle);
        return FALSE;
    }
    else if(myhead.metrics != metrics)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"image size not fit .");
        GlobalUnlock(handle);
		GlobalFree(handle);
        return FALSE;
    }
    
    pointer += sizeof(MYHEAD);
    
    compression = (unsigned int)(option & 0x0000fc00) >> 10;
    if(compression != 1 && compression != 2 && compression != 3 && compression != 4)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"compression method not support .");
        GlobalUnlock(handle);
		GlobalFree(handle);
        return FALSE;
    }
    
    width = (int)(metrics & 0x0000ffff);
    height = (int)((unsigned long)metrics >> 16);
    depth = (option & 0x000000fc) >> 2;
    color = (myhead.option & 0x00000300) >> 8;

    // Set nPredictor if use LZW compression.
    if(compression == 2)
    {
        if(depth == 24)
            nPredictor = 2;
        else if(depth == 8 && color != 3)
            nPredictor = 2;
        else
            nPredictor = 1;
    }

    if(color == 3)
        j = (3 << depth);
    else
        j = 0;
    
    bytesperline = (width * depth + 7) / 8;
    if(GlobalSize(handle) < (DWORD)((long)bytesperline * height + j + sizeof(MYHEAD)))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"memory size not fit .");
        GlobalUnlock(handle);
		GlobalFree(handle);
        return FALSE;
    }
    
    flag = 1;
    IFDNumber = TRUE;
    if(depth != 24)
        samperpixel = 1;
    else
        samperpixel = 3;
    bitpersample = depth / samperpixel;
    photometric = color;
    planar = 1;
    rowsperstrip = MAXNUMBER;
    numofstrip = 1;
    typeofstripoff = 4;
    typeofstripbytes = 4;
    istiled = FALSE;
    resolutionunit = 2;
    newsubfiletype = 0;
    
    j = 0x00004949;
    i = 42;
    ll = 8;
    
#ifdef MultiImageWriting
    if(lFileSeekBase != 8)  IFDNumber = FALSE;
#endif

#ifdef MultiImageWriting
    if(lFileSeekBase == 8)
    {
#endif

// Write the highest level header information
    SeekToBegin();
    Write((void*)&j,2);
    Write((void*)&i,2);
    Write((void*)&ll,4);

#ifdef MultiImageWriting
    }

    if(lFileSeekBase != 8)
        Seek(lFileSeekBase,CFile::begin);
#endif
    
    i = 14;
    if(color > 1)   
		i = 15;
// Addition by Yefeng Zheng starts 04/05/2005
// LibTiff does not support the tag of predictor. 
// Ignore this tag if it is un-necessary.	
	if( nPredictor == 1 )	
		i--;
// Addition by Yefeng Zheng ends 04/05/2005

// Write the first image file directory
    Write((void*)&i,2);
    
    writetag(0x00fe,4,1l,0l);
    writetag(0x0100,3,1l,(long)width);
    writetag(0x0101,3,1l,(long)height);
    
#ifdef MultiImageWriting
    longvalue = 2 + i * 12 + 4 + 8 * 2 + lFileSeekBase;
#else
    longvalue = 8 + 2 + i * 12 + 4 + 8 * 2;
#endif

    if(samperpixel == 1)
        writetag(0x0102,3,1l,(long)bitpersample);
    else
        writetag(0x0102,3,3l,longvalue);
    
    if(compression == 3)
        ll = 4l;
    else if(compression == 4)
        ll = 32773l;
    else if(compression == 2)
        ll = 5l;
    else    // compression = 1.
        ll = 1l;
    
    writetag(0x0103,3,1l,ll);
    writetag(0x0106,3,1l,(long)photometric);
    
    ll = longvalue;
    if(color == 2)
        ll = longvalue + 6;
    else if(color == 3)
        ll = longvalue + (3 << depth) * 2;
    
    writetag(0x0111,4,1l,ll);
    writetag(0x0115,3,1l,(long)samperpixel);
    writetag(0x0116,4,1l,rowsperstrip);
    
    ll = GetPosition();
    k = ll;
    
    writetag(0x0117,4,1l,0l);
    writetag(0x011a,5,1l,(longvalue - 16));
    writetag(0x011b,5,1l,(longvalue - 8));
    if(color == 2)  
		writetag(0x011c,3,1l,1l);

// Write the tag of the resolution unit
//Addition begin 10/04/02
	myhead.res_unit = 2;	// Modified on 04/05/2005
	myhead.h_res1	= 1;
	myhead.v_res1	= 1;
//Addition end

    if(myhead.res_unit == 1 || myhead.res_unit == 2 || myhead.res_unit == 3)
        writetag(0x0128,3,1l,(long)myhead.res_unit);
    else if(myhead.res_unit == 4)
        writetag(0x0128,3,1l,1l);
    else if(myhead.res_unit == 5)
        writetag(0x0128,3,1l,1l);
    else
        writetag(0x0128,3,1l,1l);

// LibTiff does not support the tag of predictor. 
// Ignore this tag if it is un-necessary.
	if( nPredictor != 1 )
	    writetag(0x013d, 3, 1l, (long)nPredictor);
    
    if(color == 3)  
		writetag(0x0140,3,(long)(3 << depth),longvalue);
    
    ll = 0;
    Write((void*)&ll,4);
 
    if(myhead.res_unit == 1 || myhead.res_unit == 2 || myhead.res_unit == 3)
    {
        Write((void*)&myhead.h_res0,4);
        Write((void*)&myhead.h_res1,4);
        Write((void*)&myhead.v_res0,4);
        Write((void*)&myhead.v_res1,4);
    }
    else if(myhead.res_unit == 4)  // add code here to replace this
    {
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
    }
    else if(myhead.res_unit == 5)   // add code here to replace this
    {
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
    }
    else
    {
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
        ll = 300;
        Write((void*)&ll,4);
        ll = 1;
        Write((void*)&ll,4);
    }
    
    if(color == 2)
    {
        ll = 0x00080008l;
        Write((void*)&ll,4);
        Write((void*)&ll,2);
    }
    
    longvalue = (long)bytesperline * height;
    if(color == 3)
    {
        for(ll=0;ll<3;ll++)
        for(i=0;i<(1<<depth);i++)
        {
            j = (int)(*(pointer + longvalue + i * 3 + ll)) << 8;
            Write((void*)&j,2);
        }
    }
    
    ll = GetPosition();
    j = ll;
    if(compression == 1)    // No compression
    {
        for(i=0; i<longvalue/1024/1024; i++)
        {
            Write((void*)(pointer+i*1024*1024), 1024*1024);
        }
        Write((void*)(pointer+i*1024*1024), longvalue-i*1024*1024);
    }
    else if(compression == 2)   // LZW
    {
        HANDLE codehandle;
        int *oldcode,*currentcode;
        int jl;
        unsigned char *newcode;
        unsigned char mask_table[8] =
        {
            0x00,0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f
        };

        // If depth is 8 or 24, use difference mode.
        if(depth == 24)
        {
            for(jl = 0; jl < height; jl ++)
            {
                for(longvalue = bytesperline - 1; longvalue > 2; longvalue --)
                {
                    *(pointer + jl * bytesperline + longvalue) -=
                        *(pointer + jl * bytesperline + longvalue - 3);
                }
            }
        }
        else if(depth == 8 && color != 3)       // 256 grayscale
        {
            for(jl = 0; jl < height; jl ++)
            {
                for(longvalue = bytesperline - 1; longvalue > 0; longvalue --)
                {
                    *(pointer + jl * bytesperline + longvalue) -=
                        *(pointer + jl * bytesperline + longvalue - 1);
                }
            }
        }

        codehandle = GlobalAlloc(GMEM_MOVEABLE,5003+5003*2*sizeof(int));
        newcode = (unsigned char*)GlobalLock(codehandle);
        if(newcode == NULL)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error allocating memory .");
            GlobalUnlock(codehandle);//Zheng Y.F. 2001/4/6
			GlobalUnlock(handle);
            GlobalFree(handle);
			return FALSE;
        }
    
        oldcode = (int*)(newcode + 5003);
        currentcode = oldcode + 5003;
    
        int prefix_code,suffix_char;
        int hx,d;
        int clear_code,eof_code;
        int max_code,free_code;
        int min_code_size;
    
        min_code_size = 8;
    
        bit_offset = 0;
        code_size = min_code_size + 1;
        clear_code = (1 << min_code_size);
        eof_code = clear_code + 1;
        free_code = clear_code + 2;
        max_code = 1 << code_size;
    
        for(i=0;i<5003;i++)     currentcode[i] = 0;
    
        write_code(clear_code);
    
        longvalue = 0;

        suffix_char = *(pointer + longvalue);
        longvalue ++;
    
        prefix_code = suffix_char;
    
        while(longvalue < (long)bytesperline * height)
        {
            suffix_char = *(pointer + longvalue);
            longvalue ++;

            hx = (prefix_code ^ (suffix_char << 5)) % 5003;
            d = 1;
        
            while(1)
            {
                if(currentcode[hx] == 0)
                {
                    write_code(prefix_code);
                    d = free_code;
                
                    if(free_code <= 4095)
                    {
                        oldcode[hx] = prefix_code;
                        newcode[hx] = (unsigned char)suffix_char;
                        currentcode[hx] = free_code;
                        free_code ++;
                    }
                
                    // ע, GIFͬ. GIFΪ if(d == max_code)
                    if(d == max_code - 1)
                    {
                        if(code_size < 12)
                        {
                            code_size ++;
                            max_code <<= 1;
                        }
                        else
                        {
                            write_code(clear_code);
                        
                            code_size = min_code_size + 1;
                            free_code = clear_code + 2;
                            max_code = 1 << code_size;
                        
                            for(jl=0;jl<5003;jl++)     currentcode[jl] = 0;
                        }
                    }
                
                    prefix_code = suffix_char;
                    break;
                }
            
                if(oldcode[hx] == prefix_code && newcode[hx] == (unsigned char)
                        suffix_char)
                {
                    prefix_code = currentcode[hx];
                    break;
                }
            
                hx += d;
                d += 2;
                if(hx >= 5003)      hx -= 5003;
            }
        }

        write_code(prefix_code);

        // ע, GIFͬ. GIFΪ if(free_code == max_code)
        if(free_code == max_code - 1)
        {
            if(code_size < 12)
            {
                code_size ++;
                max_code <<= 1;
            }
            else
            {
                write_code(clear_code);

                code_size = min_code_size + 1;
                max_code = 1 << code_size;
                        
                for(jl=0;jl<5003;jl++)     currentcode[jl] = 0;
            }
        }
    
        write_code(eof_code);

        Write((void*)code_buffer,(bit_offset + 7 ) >> 3);
		GlobalUnlock( codehandle );
		GlobalFree( codehandle );
    }
    else if(compression == 3)   // G4
    {
        if(depth != 1)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"Group4 must be bi_level image .");
            GlobalUnlock(handle);
			GlobalFree(handle);
            return FALSE;
        }
        
        GlobalUnlock(handle);
        temphandle = grp4comp(handle,longvalue,width,height,&ll);
        if(temphandle == NULL)  return FALSE;
        
        pointer = (unsigned char*)GlobalLock(temphandle);
        if(pointer == NULL)
        {
            errorflag = TRUE;
            lstrcpy((LPSTR)errormessage,"error locking memory .");
            GlobalFree(temphandle);
            return FALSE;
        }
        
        Write((void*)pointer,ll);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
    }
    else if(compression == 4)   // PackBits
    {
        for(i=0;i<height;i++)
        {
            if(!writePackBitsline((unsigned char*)pointer,bytesperline))
                return FALSE;
            pointer += bytesperline;
        }
    }
    
    ll = GetPosition();
    ll -= j;
    Seek((k + 8),CFile::begin);
    Write((void*)&ll,4);
	GlobalUnlock(handle);
	GlobalFree(handle);
    return TRUE;
}


void CTiff::writetag(int name,int type,DWORD length,DWORD offset)
{
    Write((void*)&name,2);
    Write((void*)&type,2);
    Write((void*)&length,4);
    Write((void*)&offset,4);
    
    return;
}


#ifdef _Group4

HANDLE CTiff::grp4comp(HANDLE hindata,long inbytes,int width,
            int height,long *outbytes)
{
    if(errorflag) return (NULL);
    
    if(GlobalSize(hindata) < (DWORD)(inbytes + sizeof(MYHEAD)))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"memory size not fit .");
        return (NULL);
    }
    
    int flag;
    int A0,A0_color,A1,a2,b1,b2;
    typedef struct PARAMETERS 
    {
        int previous_color;
        int index;
        int max_pixel;
        int pixel;
        int *reference_line;
        int *coding_line;
    }parameters;

    struct COMPRESSED_DESCRIPTOR 
    {
        unsigned char *data;
        int  pixels_per_line;
        int  number_of_lines;
        long length_in_bytes;
    }compressed;

    struct UNCOMPRESSED_DESCRIPTOR 
    {
        unsigned char *data;
        int  pixels_per_line;
        int  number_of_lines;
    }uncompressed;

    int comp_alloc_flag = 1;

    HANDLE houtdata;
    unsigned char* indata;
    unsigned char* outdata;
    long memorysizeofimage;
    
    memorysizeofimage = (long)height * (long)width / Pixels_per_byte;
    long size = memorysizeofimage;
    houtdata = GlobalAlloc(GMEM_MOVEABLE,memorysizeofimage);
    if(houtdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return NULL;
    }
    
    indata = (unsigned char*)GlobalLock(hindata);
    if(indata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalFree(houtdata);
        return NULL;
    }
    A1 = ((MYHEAD*)indata)->option;
    A1 &= 0x00000300;
    A1 >>= 8;
    
    indata += sizeof(MYHEAD);
    
    flag = (color != A1);
    if(flag)
    {
        for(memorysizeofimage=0;memorysizeofimage<inbytes;memorysizeofimage++)
            *(indata + memorysizeofimage) = ~(*(indata + memorysizeofimage));
    }
    
    A1 = (width + 7) / 8;
    a2 = 0x000000ff << (A1 * 8 - width);
    for(A0 = 0;A0 < height;A0++)
        *(indata + (long)A0 * A1 + A1 - 1) &= (unsigned char)a2;
    
    outdata = (unsigned char*)GlobalLock(houtdata);
    if(outdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalFree(houtdata);
        GlobalUnlock(hindata);
        return NULL;
    }
    
    uncompressed.pixels_per_line = width;
    uncompressed.number_of_lines = height;
    uncompressed.data = indata;
    comp_write_init_flag = 1;
    compressed.data = outdata;
    
    parameters    sole_parameters;
    parameters    *params = &sole_parameters;
    params->max_pixel           = uncompressed.pixels_per_line;
    compressed.pixels_per_line = uncompressed.pixels_per_line;
    compressed.number_of_lines = uncompressed.number_of_lines;
    
    HANDLE temp01,temp02;
    
    int i = (params->max_pixel + Extra_positions) * sizeof(int);
    
    temp01 = LocalAlloc(LHND,i);
    temp02 = LocalAlloc(LHND,i);
    
    if(temp01 == NULL || temp02 == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating local memory .");
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalUnlock(hindata);
        return NULL;
    }
    params->reference_line = (int *)LocalLock(temp01);
    params->coding_line = (int *)LocalLock(temp02);
    if(params->coding_line == NULL || params->reference_line == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking local memory .");
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalUnlock(hindata);
        return NULL;
    }
        
    
    *(params->reference_line + 0) = Invalid;        
    *(params->reference_line + 1) = params->max_pixel;
    *(params->reference_line + 2) = params->max_pixel;
    *(params->reference_line + 3) = params->max_pixel;
    
    *(params->coding_line) = Invalid;
    
    params->pixel = 0;
    params->index = 0;
    params->previous_color = White;

    output_area = compressed.data;

    int     line;
    int     bytes_per_line;
    long    line_offset;
    int     byte_offset;                    
    int     line_number;

    for(line = 0; line < uncompressed.number_of_lines; line++)
    {
        line_number = line;
        bytes_per_line = (params->max_pixel + 7) / Pixels_per_byte;

        line_offset = (long)bytes_per_line * (long)line_number;
        for(byte_offset=0; byte_offset < bytes_per_line; byte_offset++)
        {
            unsigned char data_byte;
            char color;
            int    ii;
            
            ii = 0;
            color = 0;
            data_byte = *(uncompressed.data+line_offset+byte_offset);

            color = -(data_byte & Last_bit_mask); 
            data_byte ^= params->previous_color; 
    
            while(table[data_byte].pixel[ii] != Invalid) 
              *( params->coding_line + ++params->index ) = 
                  params->pixel + table[data_byte].pixel[ii++];
        
            params->pixel += Pixels_per_byte;
            params->previous_color = color;

        }
        *(params->coding_line) = Invalid;
        *(params->coding_line + ++params->index) = params->max_pixel;
        *(params->coding_line + ++params->index) = params->max_pixel;
        *(params->coding_line + ++params->index) = params->max_pixel;
    
        A0 = Invalid;
        A0_color = White; 
        A1 = 1;
        int last_bit_of_b1;
    
        b1 = 1;
        last_bit_of_b1 = b1 & Last_bit_mask;
        
        while( ((*(params->reference_line +b1) <=A0) || (A0_color ==last_bit_of_b1))
             && (*(params->reference_line + b1) < params->max_pixel) )
        {
                b1++;
                last_bit_of_b1 = b1 & Last_bit_mask;
        }

        b2 = b1 + 1;
    
        do
        {
            if (*(params->reference_line + b2) < *(params->coding_line + A1))
            {
                if(!write_bits_c("0001",size))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                    LocalUnlock(temp01);
                    LocalUnlock(temp02);
                    LocalFree(temp01);
                    LocalFree(temp02);
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalFree(houtdata);
                    return (NULL);
                }

                A0 = *(params->reference_line + b2);
                b1 += 2;
                b2 += 2;
            }
            else if(abs(*(params->coding_line+A1)-*(params->reference_line+b1)) <=3)
            {
                int difference;
                difference = *(params->coding_line + A1) - *(params->reference_line + b1);
                A0 = *(params->coding_line + A1);
                A0_color = !A0_color;
                A1++;
    
                switch(difference) 
                {
                    case 0:     
                        if(!write_bits_c("1",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }

                        if(*(params->reference_line + b1) != params->max_pixel ) 
                        {
                            b1++;
                            b2++;
                        }
                        break;

                    case 1:         
                        if(!write_bits_c("011",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        b1++;
                        b2++;
                        if((*(params->reference_line + b1) <= A0)  && 
                        (*(params->reference_line + b1) != params->max_pixel) ) 
                        {
                            b1 += 2;
                            b2 += 2;
                        }
                        break;

                    case -1:    
                        if(!write_bits_c("010",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        if(*(params->reference_line + b1) != params->max_pixel ) 
                        {
                            b1++;
                            b2++;
                        }
                        break;

                    case 2:     
                        if(!write_bits_c("000011",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        b1++;
                        b2++;
                        if((*(params->reference_line + b1) <= A0)  && 
                        (*(params->reference_line + b1) != params->max_pixel) ) 
                        {
                            b1 += 2;
                            b2 += 2;
                        }
                        break;

                    case -2:    
                        if(!write_bits_c("000010",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        if(*(params->reference_line + b1 - 1) > A0 ) 
                        {
                            b1--;
                            b2--;
                        }
                        else if(*(params->reference_line + b1) != params->max_pixel)
                        {
                            b1++;
                            b2++;
                        }                       
                        break;

                    case 3:     
                        if(!write_bits_c("0000011",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        b1++;
                        b2++;
                        while ((*(params->reference_line + b1) <= A0)  && 
                        (*(params->reference_line + b1) != params->max_pixel) ) 
                        {
                            b1 += 2;
                            b2 += 2;
                        }
                        break;

                    case -3:    
                        if(!write_bits_c("0000010",size))
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                            LocalUnlock(temp01);
                            LocalUnlock(temp02);
                            LocalFree(temp01);
                            LocalFree(temp02);
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalFree(houtdata);
                            return (NULL);
                        }
                        
                        if(*(params->reference_line + b1 - 1) > A0 ) 
                        {
                            b1--;
                            b2--;
                        }
                        else if(*(params->reference_line + b1) != params->max_pixel)
                        {
                            b1++;
                            b2++;
                        }               
                        break;

                    default: 
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,"error in vertical mode .");
                        LocalUnlock(temp01);
                        LocalUnlock(temp02);
                        LocalFree(temp01);
                        LocalFree(temp02);
                        GlobalUnlock(hindata);
                        GlobalUnlock(houtdata);
                        GlobalFree(houtdata);
                        return NULL;

                }
            }   

            else 
            {
                int run_length;

                a2 = A1 + 1;
                if(!write_bits_c("001",size))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                    LocalUnlock(temp01);
                    LocalUnlock(temp02);
                    LocalFree(temp01);
                    LocalFree(temp02);
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalFree(houtdata);
                    return (NULL);
                }
                
    
                if(A0 == Invalid)
                    run_length = *(params->coding_line + A1);       
                else
                    run_length = *(params->coding_line + A1) - A0;
                if(!write_run_length(run_length, A0_color ,size))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                    LocalUnlock(temp01);
                    LocalUnlock(temp02);
                    LocalFree(temp01);
                    LocalFree(temp02);
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalFree(houtdata);
                    return (NULL);
                }
                
    
                run_length = *(params->coding_line + a2) - *(params->coding_line + A1);
                if(!write_run_length(run_length, !A0_color,size))
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
                    LocalUnlock(temp01);
                    LocalUnlock(temp02);
                    LocalFree(temp01);
                    LocalFree(temp02);
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalFree(houtdata);
                    return (NULL);
                }
                
        
                A0 = *(params->coding_line + a2);
                A1 = a2 + 1;
    
                while((*(params->reference_line + b1) <= *(params->coding_line + a2)) &&
                    ( *(params->reference_line + b1) < params->max_pixel)  )
                {
                    b1 += 2;
                    b2 += 2;
                }
            
            }
        } while( A0 < params->max_pixel);
    
        int *temp;
    
        temp = params->reference_line;
        params->reference_line = params->coding_line;
        params->coding_line = temp;
    
        params->pixel = 0;
        params->index = 0;
        params->previous_color = White;
    }
    
    if(!write_bits_c("000000000001000000000001",size))
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"Group4 can't benefit this image .");
        LocalUnlock(temp01);
        LocalUnlock(temp02);
        LocalFree(temp01);
        LocalFree(temp02);
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        return (NULL);
    }
    
    int iii;

    if (bit_place_mark != 0) 
    {
        for (iii=bit_place_mark; iii<Pixels_per_byte; iii++)
              *(output_area + byte_place_mark) &= write_zero[iii];
        ++byte_place_mark;
    }

    compressed.length_in_bytes = byte_place_mark;

    LocalUnlock(temp01);
    LocalUnlock(temp02);
    LocalFree(temp01);
    LocalFree(temp02);
    
    *outbytes = compressed.length_in_bytes;
    GlobalUnlock(houtdata);

    if(flag)
    {
        for(memorysizeofimage=0;memorysizeofimage<inbytes;memorysizeofimage++)
            *(indata + memorysizeofimage) = ~(*(indata + memorysizeofimage));
    }
    
    GlobalUnlock(hindata);
    return (houtdata);
}


BOOL CTiff::write_bits_c(char* string_ptr,long size)
{
    if(comp_write_init_flag)
    {
        bit_place_mark = 0;
        byte_place_mark = 0;
        comp_write_init_flag = 0;
    }
    while(*string_ptr != NULL) 
    {
        if(*string_ptr == '1')
            *(output_area + byte_place_mark) |= write_one[bit_place_mark];
        else
            *(output_area + byte_place_mark) &= write_zero[bit_place_mark];
        
        if(bit_place_mark == Last_bit_in_a_byte) 
        {
            bit_place_mark = 0;
            byte_place_mark++;
            
            if(byte_place_mark >= size) return FALSE;
        }
        else
            bit_place_mark++;
        string_ptr++;
    }
    
    return TRUE;
} 


BOOL CTiff::write_run_length(int length, int color,long size)
{
    int     multiples_of_largest_code,          
            make_up_code_index, 
            remainder,
            i;  
        
    multiples_of_largest_code = length / Largest_code;
    length %= Largest_code;
    for(i=0 ; i < multiples_of_largest_code ; i++) 
        if(!write_bits_c( largest_colorless_code ,size))    return FALSE;

    remainder = length % 64;
    
    make_up_code_index = length / 64;
    
    make_up_code_index--;
    
    if(make_up_code_index != Invalid) 
    {    
        if(color == White)
        {
            if(!write_bits_c((white_make_up_code+13*make_up_code_index),size))
                return FALSE;
        }
        else
        {
            if(!write_bits_c((black_make_up_code+14 * make_up_code_index),size))
                return FALSE;
        }
    }
    
    if(color == White)
    {
        if(!write_bits_c((white_terminating_code + 9 * remainder),size))
            return FALSE;
    }
    else
    {
        if(!write_bits_c((black_terminating_code + 13 * remainder),size))
            return FALSE;
    }
    
    return TRUE;
}


void CTiff::setstaticdata(void)
{
    int i,j;
    HANDLE temphandle;
    char *temppointer;

#ifndef NoOuterDataFile
    HFILE filehandle;
    OFSTRUCT of_struct;
    char *currentpointer;
    char buffer[80],szFilenameBuffer[180];
    byte_descriptor bd;
    node nd;
    
    char convertbuffer[20];
    int converti,convertj;
#endif
    
    largest_colorless_code = "000000011111";
    unsigned char tempwrite_one[Pixels_per_byte] = 
    {
        (unsigned char)0x80,
        (unsigned char)0x40,
        (unsigned char)0x20,
        (unsigned char)0x10,
        (unsigned char)0x8,
        (unsigned char)0x4,
        (unsigned char)0x2,
        (unsigned char)0x1,
    };
    for(i=0;i<Pixels_per_byte;i++) write_one[i] = tempwrite_one[i];

    unsigned char tempwrite_zero[Pixels_per_byte] =
    {
        (unsigned char)0x7F,
        (unsigned char)0xBF,
        (unsigned char)0xDF,
        (unsigned char)0xEF,
        (unsigned char)0xF7,
        (unsigned char)0xFB,
        (unsigned char)0xFD,
        (unsigned char)0xFE,
    };
    for(i=0;i<Pixels_per_byte;i++) write_zero[i] = tempwrite_zero[i];

    i = 9*64+13*64+13*40+14*40+9*256*sizeof(int)+3*208*sizeof(int)+3*208*sizeof(int);
    static_data_handle = GlobalAlloc(GMEM_MOVEABLE,i);
    white_terminating_code = (char*)GlobalLock(static_data_handle);
    if(white_terminating_code == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        return ;
    }
    
    black_terminating_code = white_terminating_code + 9 * 64;
    white_make_up_code = black_terminating_code + 13 * 64;
    black_make_up_code = white_make_up_code + 13 * 40;
    table = (byte_descriptor*)(black_make_up_code + 14 * 40);
    white_tree = (node*)((char*)table + 9 * 256 * sizeof(int));
    black_tree = (node*)((char*)white_tree + 3 * 208 * sizeof(int));
    
    temphandle = GlobalAlloc(GMEM_MOVEABLE,15000);
    temppointer = (char*)GlobalLock(temphandle);
    if(temppointer == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        return;
    }
    
#ifdef NoOuterDataFile
    char white_terminating_code_temp[64][9] =
    {
                "00110101",
                "000111",
                "0111",
                "1000",
                "1011",
                "1100",
                "1110",
                "1111",
                "10011",
                "10100",
                "00111",
                "01000",
                "001000",
                "000011",
                "110100",
                "110101",
                "101010",
                "101011",
                "0100111",
                "0001100",
                "0001000",
                "0010111",
                "0000011",
                "0000100",
                "0101000",
                "0101011",
                "0010011",
                "0100100",
                "0011000",
                "00000010",
                "00000011",
                "00011010",
                "00011011",
                "00010010",
                "00010011",
                "00010100",
                "00010101",
                "00010110",
                "00010111",
                "00101000",
                "00101001",
                "00101010",
                "00101011",
                "00101100",
                "00101101",
                "00000100",
                "00000101",
                "00001010",
                "00001011",
                "01010010",
                "01010011",
                "01010100",
                "01010101",
                "00100100",
                "00100101",
                "01011000",
                "01011001",
                "01011010",
                "01011011",
                "01001010",
                "01001011",
                "00110010",
                "00110011",
                "00110100",
    };
    memcpy(white_terminating_code,white_terminating_code_temp,64*9);

    char black_terminating_code_temp[64][13] =
    {
        "0000110111",
        "010",
        "11",
        "10",
        "011",
        "0011",
        "0010",
        "00011",
        "000101",
        "000100",
        "0000100",
        "0000101",
        "0000111",
        "00000100",
        "00000111",
        "000011000",
        "0000010111",
        "0000011000",
        "0000001000",
        "00001100111",
        "00001101000",
        "00001101100",
        "00000110111",
        "00000101000",
        "00000010111",
        "00000011000",
        "000011001010",
        "000011001011",
        "000011001100",
        "000011001101",
        "000001101000",
        "000001101001",
        "000001101010",
        "000001101011",
        "000011010010",
        "000011010011",
        "000011010100",
        "000011010101",
        "000011010110",
        "000011010111",
        "000001101100",
        "000001101101",
        "000011011010",
        "000011011011",
        "000001010100",
        "000001010101",
        "000001010110",
        "000001010111",
        "000001100100",
        "000001100101",
        "000001010010",
        "000001010011",
        "000000100100",
        "000000110111",
        "000000111000",
        "000000100111",
        "000000101000",
        "000001011000",
        "000001011001",
        "000000101011",
        "000000101100",
        "000001011010",
        "000001100110",
        "000001100111",
    };
    memcpy(black_terminating_code,black_terminating_code_temp,64*13);

    char white_make_up_code_temp[40][13] = 
    {
        "11011",
        "10010",
        "010111",
        "0110111",
        "00110110",
        "00110111",
        "01100100",
        "01100101",
        "01101000",
        "01100111",
        "011001100",
        "011001101",
        "011010010",
        "011010011",
        "011010100",
        "011010101",
        "011010110",
        "011010111",
        "011011000",
        "011011001",
        "011011010",
        "011011011",
        "010011000",
        "010011001",
        "010011010",
        "011000",
        "010011011",
        "00000001000",
        "00000001100",
        "00000001101",
        "000000010010",
        "000000010011",
        "000000010100",
        "000000010101",
        "000000010110",
        "000000010111",
        "000000011100",
        "000000011101",
        "000000011110",
        "000000011111",
    };
    memcpy(white_make_up_code,white_make_up_code_temp,40*13);

    char black_make_up_code_temp[40][14] =
    {
        "0000001111",
        "000011001000",
        "000011001001",
        "000001011011",
        "000000110011",
        "000000110100",
        "000000110101",
        "0000001101100",
        "0000001101101",
        "0000001001010",
        "0000001001011",
        "0000001001100",
        "0000001001101",
        "0000001110010",
        "0000001110011",
        "0000001110100",
        "0000001110101",
        "0000001110110",
        "0000001110111",
        "0000001010010",
        "0000001010011",
        "0000001010100",
        "0000001010101",
        "0000001011010",
        "0000001011011",
        "0000001100100",
        "0000001100101",
        "00000001000",
        "00000001100",
        "00000001101",
        "000000010010",
        "000000010011",
        "000000010100",
        "000000010101",
        "000000010110",
        "000000010111",
        "000000011100",
        "000000011101",
        "000000011110",
        "000000011111",
    };
    memcpy(black_make_up_code,black_make_up_code_temp,40*14);

    int table_temp[256][9] =
    {
       -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        6,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        5,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        5,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        5,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    5,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    5,    6,    7,   -1,   -1,   -1,   -1,   -1,
        4,    5,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        4,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    4,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    4,    6,    7,   -1,   -1,   -1,   -1,   -1,
        3,    4,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    4,    5,    6,   -1,   -1,   -1,   -1,   -1,
        3,    4,    5,    6,    7,   -1,   -1,   -1,   -1,
        3,    4,    5,    7,   -1,   -1,   -1,   -1,   -1,
        3,    4,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    5,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    5,    6,    7,   -1,   -1,   -1,   -1,   -1,
        3,    5,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        3,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        3,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    3,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    3,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    3,    6,    7,   -1,   -1,   -1,   -1,   -1,
        2,    3,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    3,    5,    6,   -1,   -1,   -1,   -1,   -1,
        2,    3,    5,    6,    7,   -1,   -1,   -1,   -1,
        2,    3,    5,    7,   -1,   -1,   -1,   -1,   -1,
        2,    3,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    3,    4,    5,   -1,   -1,   -1,   -1,   -1,
        2,    3,    4,    5,    7,   -1,   -1,   -1,   -1,
        2,    3,    4,    5,    6,    7,   -1,   -1,   -1,
        2,    3,    4,    5,    6,   -1,   -1,   -1,   -1,
        2,    3,    4,    6,   -1,   -1,   -1,   -1,   -1,
        2,    3,    4,    6,    7,   -1,   -1,   -1,   -1,
        2,    3,    4,    7,   -1,   -1,   -1,   -1,   -1,
        2,    3,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    4,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    4,    6,    7,   -1,   -1,   -1,   -1,   -1,
        2,    4,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    4,    5,    6,   -1,   -1,   -1,   -1,   -1,
        2,    4,    5,    6,    7,   -1,   -1,   -1,   -1,
        2,    4,    5,    7,   -1,   -1,   -1,   -1,   -1,
        2,    4,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    5,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    5,    6,    7,   -1,   -1,   -1,   -1,   -1,
        2,    5,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        2,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        2,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,    6,    7,   -1,   -1,   -1,   -1,   -1,
        1,    2,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,    5,    6,   -1,   -1,   -1,   -1,   -1,
        1,    2,    5,    6,    7,   -1,   -1,   -1,   -1,
        1,    2,    5,    7,   -1,   -1,   -1,   -1,   -1,
        1,    2,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,    4,    5,   -1,   -1,   -1,   -1,   -1,
        1,    2,    4,    5,    7,   -1,   -1,   -1,   -1,
        1,    2,    4,    5,    6,    7,   -1,   -1,   -1,
        1,    2,    4,    5,    6,   -1,   -1,   -1,   -1,
        1,    2,    4,    6,   -1,   -1,   -1,   -1,   -1,
        1,    2,    4,    6,    7,   -1,   -1,   -1,   -1,
        1,    2,    4,    7,   -1,   -1,   -1,   -1,   -1,
        1,    2,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    2,    3,    4,   -1,   -1,   -1,   -1,   -1,
        1,    2,    3,    4,    7,   -1,   -1,   -1,   -1,
        1,    2,    3,    4,    6,    7,   -1,   -1,   -1,
        1,    2,    3,    4,    6,   -1,   -1,   -1,   -1,
        1,    2,    3,    4,    5,    6,   -1,   -1,   -1,
        1,    2,    3,    4,    5,    6,    7,   -1,   -1,
        1,    2,    3,    4,    5,    7,   -1,   -1,   -1,
        1,    2,    3,    4,    5,   -1,   -1,   -1,   -1,
        1,    2,    3,    5,   -1,   -1,   -1,   -1,   -1,
        1,    2,    3,    5,    7,   -1,   -1,   -1,   -1,
        1,    2,    3,    5,    6,    7,   -1,   -1,   -1,
        1,    2,    3,    5,    6,   -1,   -1,   -1,   -1,
        1,    2,    3,    6,   -1,   -1,   -1,   -1,   -1,
        1,    2,    3,    6,    7,   -1,   -1,   -1,   -1,
        1,    2,    3,    7,   -1,   -1,   -1,   -1,   -1,
        1,    2,    3,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    3,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    3,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    3,    6,    7,   -1,   -1,   -1,   -1,   -1,
        1,    3,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    3,    5,    6,   -1,   -1,   -1,   -1,   -1,
        1,    3,    5,    6,    7,   -1,   -1,   -1,   -1,
        1,    3,    5,    7,   -1,   -1,   -1,   -1,   -1,
        1,    3,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    3,    4,    5,   -1,   -1,   -1,   -1,   -1,
        1,    3,    4,    5,    7,   -1,   -1,   -1,   -1,
        1,    3,    4,    5,    6,    7,   -1,   -1,   -1,
        1,    3,    4,    5,    6,   -1,   -1,   -1,   -1,
        1,    3,    4,    6,   -1,   -1,   -1,   -1,   -1,
        1,    3,    4,    6,    7,   -1,   -1,   -1,   -1,
        1,    3,    4,    7,   -1,   -1,   -1,   -1,   -1,
        1,    3,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    4,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    4,    6,    7,   -1,   -1,   -1,   -1,   -1,
        1,    4,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    4,    5,    6,   -1,   -1,   -1,   -1,   -1,
        1,    4,    5,    6,    7,   -1,   -1,   -1,   -1,
        1,    4,    5,    7,   -1,   -1,   -1,   -1,   -1,
        1,    4,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    5,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    5,    6,    7,   -1,   -1,   -1,   -1,   -1,
        1,    5,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        1,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    6,    7,   -1,   -1,   -1,   -1,   -1,
        0,    1,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    5,    6,   -1,   -1,   -1,   -1,   -1,
        0,    1,    5,    6,    7,   -1,   -1,   -1,   -1,
        0,    1,    5,    7,   -1,   -1,   -1,   -1,   -1,
        0,    1,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    4,    5,   -1,   -1,   -1,   -1,   -1,
        0,    1,    4,    5,    7,   -1,   -1,   -1,   -1,
        0,    1,    4,    5,    6,    7,   -1,   -1,   -1,
        0,    1,    4,    5,    6,   -1,   -1,   -1,   -1,
        0,    1,    4,    6,   -1,   -1,   -1,   -1,   -1,
        0,    1,    4,    6,    7,   -1,   -1,   -1,   -1,
        0,    1,    4,    7,   -1,   -1,   -1,   -1,   -1,
        0,    1,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    3,    4,   -1,   -1,   -1,   -1,   -1,
        0,    1,    3,    4,    7,   -1,   -1,   -1,   -1,
        0,    1,    3,    4,    6,    7,   -1,   -1,   -1,
        0,    1,    3,    4,    6,   -1,   -1,   -1,   -1,
        0,    1,    3,    4,    5,    6,   -1,   -1,   -1,
        0,    1,    3,    4,    5,    6,    7,   -1,   -1,
        0,    1,    3,    4,    5,    7,   -1,   -1,   -1,
        0,    1,    3,    4,    5,   -1,   -1,   -1,   -1,
        0,    1,    3,    5,   -1,   -1,   -1,   -1,   -1,
        0,    1,    3,    5,    7,   -1,   -1,   -1,   -1,
        0,    1,    3,    5,    6,    7,   -1,   -1,   -1,
        0,    1,    3,    5,    6,   -1,   -1,   -1,   -1,
        0,    1,    3,    6,   -1,   -1,   -1,   -1,   -1,
        0,    1,    3,    6,    7,   -1,   -1,   -1,   -1,
        0,    1,    3,    7,   -1,   -1,   -1,   -1,   -1,
        0,    1,    3,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,    3,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,    3,    7,   -1,   -1,   -1,   -1,
        0,    1,    2,    3,    6,    7,   -1,   -1,   -1,
        0,    1,    2,    3,    6,   -1,   -1,   -1,   -1,
        0,    1,    2,    3,    5,    6,   -1,   -1,   -1,
        0,    1,    2,    3,    5,    6,    7,   -1,   -1,
        0,    1,    2,    3,    5,    7,   -1,   -1,   -1,
        0,    1,    2,    3,    5,   -1,   -1,   -1,   -1,
        0,    1,    2,    3,    4,    5,   -1,   -1,   -1,
        0,    1,    2,    3,    4,    5,    7,   -1,   -1,
        0,    1,    2,    3,    4,    5,    6,    7,   -1,
        0,    1,    2,    3,    4,    5,    6,   -1,   -1,
        0,    1,    2,    3,    4,    6,   -1,   -1,   -1,
        0,    1,    2,    3,    4,    6,    7,   -1,   -1,
        0,    1,    2,    3,    4,    7,   -1,   -1,   -1,
        0,    1,    2,    3,    4,   -1,   -1,   -1,   -1,
        0,    1,    2,    4,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,    4,    7,   -1,   -1,   -1,   -1,
        0,    1,    2,    4,    6,    7,   -1,   -1,   -1,
        0,    1,    2,    4,    6,   -1,   -1,   -1,   -1,
        0,    1,    2,    4,    5,    6,   -1,   -1,   -1,
        0,    1,    2,    4,    5,    6,    7,   -1,   -1,
        0,    1,    2,    4,    5,    7,   -1,   -1,   -1,
        0,    1,    2,    4,    5,   -1,   -1,   -1,   -1,
        0,    1,    2,    5,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,    5,    7,   -1,   -1,   -1,   -1,
        0,    1,    2,    5,    6,    7,   -1,   -1,   -1,
        0,    1,    2,    5,    6,   -1,   -1,   -1,   -1,
        0,    1,    2,    6,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,    6,    7,   -1,   -1,   -1,   -1,
        0,    1,    2,    7,   -1,   -1,   -1,   -1,   -1,
        0,    1,    2,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,    6,    7,   -1,   -1,   -1,   -1,   -1,
        0,    2,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,    5,    6,   -1,   -1,   -1,   -1,   -1,
        0,    2,    5,    6,    7,   -1,   -1,   -1,   -1,
        0,    2,    5,    7,   -1,   -1,   -1,   -1,   -1,
        0,    2,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,    4,    5,   -1,   -1,   -1,   -1,   -1,
        0,    2,    4,    5,    7,   -1,   -1,   -1,   -1,
        0,    2,    4,    5,    6,    7,   -1,   -1,   -1,
        0,    2,    4,    5,    6,   -1,   -1,   -1,   -1,
        0,    2,    4,    6,   -1,   -1,   -1,   -1,   -1,
        0,    2,    4,    6,    7,   -1,   -1,   -1,   -1,
        0,    2,    4,    7,   -1,   -1,   -1,   -1,   -1,
        0,    2,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    2,    3,    4,   -1,   -1,   -1,   -1,   -1,
        0,    2,    3,    4,    7,   -1,   -1,   -1,   -1,
        0,    2,    3,    4,    6,    7,   -1,   -1,   -1,
        0,    2,    3,    4,    6,   -1,   -1,   -1,   -1,
        0,    2,    3,    4,    5,    6,   -1,   -1,   -1,
        0,    2,    3,    4,    5,    6,    7,   -1,   -1,
        0,    2,    3,    4,    5,    7,   -1,   -1,   -1,
        0,    2,    3,    4,    5,   -1,   -1,   -1,   -1,
        0,    2,    3,    5,   -1,   -1,   -1,   -1,   -1,
        0,    2,    3,    5,    7,   -1,   -1,   -1,   -1,
        0,    2,    3,    5,    6,    7,   -1,   -1,   -1,
        0,    2,    3,    5,    6,   -1,   -1,   -1,   -1,
        0,    2,    3,    6,   -1,   -1,   -1,   -1,   -1,
        0,    2,    3,    6,    7,   -1,   -1,   -1,   -1,
        0,    2,    3,    7,   -1,   -1,   -1,   -1,   -1,
        0,    2,    3,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    3,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    3,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    3,    6,    7,   -1,   -1,   -1,   -1,   -1,
        0,    3,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    3,    5,    6,   -1,   -1,   -1,   -1,   -1,
        0,    3,    5,    6,    7,   -1,   -1,   -1,   -1,
        0,    3,    5,    7,   -1,   -1,   -1,   -1,   -1,
        0,    3,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    3,    4,    5,   -1,   -1,   -1,   -1,   -1,
        0,    3,    4,    5,    7,   -1,   -1,   -1,   -1,
        0,    3,    4,    5,    6,    7,   -1,   -1,   -1,
        0,    3,    4,    5,    6,   -1,   -1,   -1,   -1,
        0,    3,    4,    6,   -1,   -1,   -1,   -1,   -1,
        0,    3,    4,    6,    7,   -1,   -1,   -1,   -1,
        0,    3,    4,    7,   -1,   -1,   -1,   -1,   -1,
        0,    3,    4,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    4,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    4,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    4,    6,    7,   -1,   -1,   -1,   -1,   -1,
        0,    4,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    4,    5,    6,   -1,   -1,   -1,   -1,   -1,
        0,    4,    5,    6,    7,   -1,   -1,   -1,   -1,
        0,    4,    5,    7,   -1,   -1,   -1,   -1,   -1,
        0,    4,    5,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    5,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    5,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    5,    6,    7,   -1,   -1,   -1,   -1,   -1,
        0,    5,    6,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    6,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    6,    7,   -1,   -1,   -1,   -1,   -1,   -1,
        0,    7,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
        0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
    };
    for(i=0;i<256;i++)
    {
        for(j=0;j<9;j++)
            table[i].pixel[j] = table_temp[i][j];
    }

    int white_tree_temp[208][3] = 
    {
          -1,     2,     1,
          -1,     4,     3,
          -1,     6,     5,
          -1,     8,     7,
          -1,    10,     9,
          -1,    12,    11,
          -1,    14,    13,
          -1,    16,    15,
          -1,    18,    17,
          -1,    20,    19,
          -1,    22,    21,
          -1,    24,    23,
          -1,    26,    25,
          -1,    28,    27,
          -1,    30,    29,
           7,    0,                0,            
           6,    0,                0,            
          -1,    32,    31,
           5,    0,                0,            
           4,    0,                0,            
          -1,    34,    33,
          -1,    36,    35,
           3,    0,                0,            
           2,    0,                0,            
          -1,    38,    37,
          -1,    40,    39,
          -1,    42,    41,
          -1,    44,    43,
          -1,    46,    45,
          -1,    48,    47,
          -1,    50,    49,
          64,    0,                0,            
          -1,    52,    51,
          -1,    54,    53,
           9,    0,                0,            
           8,    0,                0,            
         128,    0,                0,            
          -1,    56,    55,
          -1,    58,    57,
          -1,    60,    59,
          -1,    62,    61,
          -1,    64,    63,
          11,    0,                0,            
          10,    0,                0,            
          -1,    66,    65,
          -1,    68,    67,
          -1,    70,    69,
          -1,    72,    71,
          -1,    74,    73,
          -1,    76,    75,
          -1,    78,    77,
          15,    0,                0,            
          14,    0,                0,            
          17,    0,                0,            
          16,    0,                0,            
          -1,    80,    79,
          -1,    82,    81,
          -1,    84,    83,
        1664,    0,                0,            
         192,    0,                0,            
          -1,    86,    85,
          -1,    88,    87,
          -1,    90,    89,
          -1,    92,    91,
          -1,    94,    93,
          -1,    96,    95,
          -1,    98,    97,
          -1,    100,    99,
          -1,    102,    101,
          -1,    104,    103,
          12,    0,                0,            
           1,    0,                0,            
          -1,    106,    105,
          -1,    108,    107,
          -1,    110,    109,
          13,    0,                0,            
          -1,    112,    111,
          -1,    114,    113,
          -1,    116,    115,
         256,    0,                0,            
          -1,    118,    117,
          -1,    120,    119,
          -1,    122,    121,
          -1,    124,    123,
          -1,    126,    125,
          -1,    128,    127,
          -1,    130,    129,
          25,    0,                0,            
          -1,    132,    131,
          -1,    134,    133,
          24,    0,                0,            
          18,    0,                0,            
          -1,    136,    135,
          -1,    138,    137,
          27,    0,                0,            
          -1,    140,    139,
          -1,    142,    141,
          -1,    144,    143,
          28,    0,                0,            
          21,    0,                0,            
          -1,    146,    145,
          -1,    148,    147,
          -1,    150,    149,
          26,    0,                0,            
          -1,    152,    151,
          -1,    154,    153,
          19,    0,                0,            
          -1,    156,    155,
          -1,    158,    157,
          -1,    160,    159,
          20,    0,                0,            
          -1,    162,    161,
          23,    0,                0,            
          22,    0,                0,            
          -1,    164,    163,
          -1,    166,    165,
          -1,    0,                167,
          -1,    169,    168,
          -1,    171,    170,
          -1,    173,    172,
          -1,    175,    174,
          -1,    177,    176,
         576,    0,                0,            
         640,    0,                0,            
          -1,    179,    178,
         512,    0,                0,            
         448,    0,                0,            
          58,    0,                0,            
          57,    0,                0,            
          56,    0,                0,            
          55,    0,                0,            
          52,    0,                0,            
          51,    0,                0,            
          50,    0,                0,            
          49,    0,                0,            
          -1,    181,    180,
          -1,    183,    182,
          60,    0,                0,            
          59,    0,                0,            
         384,    0,                0,            
         320,    0,                0,            
           0,    0,                0,            
          63,    0,                0,            
          62,    0,                0,            
          61,    0,                0,            
          44,    0,                0,            
          43,    0,                0,            
          42,    0,                0,            
          41,    0,                0,            
          40,    0,                0,            
          39,    0,                0,            
          54,    0,                0,            
          53,    0,                0,            
          32,    0,                0,            
          31,    0,                0,            
          38,    0,                0,            
          37,    0,                0,            
          36,    0,                0,            
          35,    0,                0,            
          34,    0,                0,            
          33,    0,                0,            
          48,    0,                0,            
          47,    0,                0,            
          46,    0,                0,            
          45,    0,                0,            
          30,    0,                0,            
          29,    0,                0,            
          -1,    185,    184,
        1408,    0,                0,            
        1344,    0,                0,            
        1280,    0,                0,            
        1216,    0,                0,            
        1152,    0,                0,            
        1088,    0,                0,            
        1024,    0,                0,            
         960,    0,                0,            
         896,    0,                0,            
         832,    0,                0,            
         768,    0,                0,            
         704,    0,                0,            
        1728,    0,                0,            
        1600,    0,                0,            
        1536,    0,                0,            
        1472,    0,                0,            
          -1,    187,    186,
          -1,    189,    188,
          -1,    191,    190,
          -1,    193,    192,
          -1,    195,    194,
          -1,    197,    196,
          -1,    199,    198,
          -1,    201,    200,
        1920,    0,                0,            
        1856,    0,                0,            
          -1,    203,    202,
          -1,    205,    204,
          -1,    207,    206,
        1792,    0,                0,            
        2560,    0,                0,            
        2496,    0,                0,            
        2432,    0,                0,            
        2368,    0,                0,            
        2304,    0,                0,            
        2240,    0,                0,            
        2176,    0,                0,            
        2112,    0,                0,            
        2048,    0,                0,            
        1984,    0,                0,            
    };
    for(i=0;i<208;i++)
    {
        white_tree[i].value = white_tree_temp[i][0];
        white_tree[i].child_zero = white_tree_temp[i][1];
        white_tree[i].child_one = white_tree_temp[i][2];
    }

    int black_tree_temp[208][3] =
    {
          -1,    2,    1,
          -1,    4,    3,
          -1,    6,    5,
           2,    0,    0,            
           3,    0,    0,            
          -1,    8,    7,
          -1,    10,   9,
           4,    0,    0,            
           1,    0,    0,            
          -1,    12,   11,
          -1,    14,   13,
           5,    0,    0,            
           6,    0,    0,            
          -1,    16,   15,
          -1,    18,   17,
           7,    0,    0,            
          -1,    20,   19,
          -1,    22,   21,
          -1,    24,   23,
           8,    0,    0,            
           9,    0,    0,            
          -1,    26,   25,
          -1,    28,   27,
          -1,    30,   29,
          -1,    32,   31,
          12,    0,    0,            
          -1,    34,   33,
          11,    0,    0,            
          10,    0,    0,            
          -1,    36,   35,
          -1,    38,   37,
          -1,    40,   39,
          -1,    0,    41,
          -1,    43,   42,
          -1,    45,   44,
          14,    0,    0,            
          -1,    47,   46,
          -1,      49,      48,
          13,    0,                0,            
          -1,      51,      50,
          -1,      53,      52,
          -1,      55,      54,
          -1,      57,      56,
          -1,      59,      58,
          -1,      61,      60,
          15,    0,                0,            
          -1,      63,      62,
          -1,      65,      64,
          -1,      67,      66,
          -1,      69,      68,
          -1,      71,      70,
          -1,      73,      72,
          -1,      75,      74,
          -1,      77,      76,
          -1,      79,      78,
          -1,      81,      80,
           0,    0,                0,            
          -1,      83,      82,
          -1,      85,      84,
          -1,      87,      86,
          -1,      89,      88,
          -1,      91,      90,
          -1,      93,      92,
          -1,      95,      94,
          -1,      97,      96,
          17,    0,               0,            
          16,    0,                0,            
          -1,      99,      98,
          -1,     101,     100,
          -1,     103,     102,
          64,    0,                0,            
          -1,     105,     104,
          -1,     107,     106,
          -1,     109,     108,
          -1,     111,     110,
          -1,     113,     112,
          -1,     115,     114,
          18,    0,                0,            
          -1,     117,     116,
          -1,     119,     118,
          -1,     121,     120,
          -1,     123,     122,
          -1,     125,     124,
          21,    0,                0,            
          -1,     127,     126,
          -1,     129,     128,
          -1,     131,     130,
          20,    0,                0,            
          19,    0,                0,            
          -1,     133,     132,
          -1,     135,     134,
          -1,     137,     136,
          22,    0,                0,            
          -1,     139,     138,
          -1,     141,     140,
          -1,     143,     142,
          -1,     145,     144,
          -1,     147,     146,
          -1,     149,     148,
          -1,     151,     150,
          -1,     153,     152,
          -1,     155,     154,
          -1,     157,     156,
          23,    0,                0,            
          -1,     159,     158,
          -1,     161,     160,
          -1,     163,     162,
          -1,     165,     164,
          -1,     167,     166,
          25,    0,                0,            
          24,    0,                0,            
          -1,     169,     168,
          -1,     171,     170,
          -1,     173,     172,
          -1,     175,     174,
          -1,     177,     176,
          -1,     179,     178,
          -1,     181,     180,
        1920,    0,                0,            
        1856,    0,                0,            
          -1,     183,     182,
          -1,     185,     184,
          -1,     187,     186,
        1792,    0,                0,            
          43,    0,                0,            
          42,    0,                0,            
          39,    0,                0,            
          38,    0,                0,            
          37,    0,                0,            
          36,    0,                0,            
          35,    0,                0,            
          34,    0,                0,            
          29,    0,                0,            
          28,    0,                0,            
          27,    0,                0,            
          26,    0,                0,            
         192,    0,                0,            
         128,    0,                0,            
          41,    0,                0,            
          40,    0,                0,            
          33,    0,                0,            
          32,    0,                0,            
          31,    0,                0,            
          30,    0,                0,            
          63,    0,                0,            
          62,    0,                0,            
          49,    0,                0,            
          48,    0,                0,            
         256,    0,                0,            
          61,    0,                0,            
          58,    0,                0,            
          57,    0,                0,            
          47,    0,                0,            
          46,    0,                0,            
          45,    0,                0,            
          44,    0,                0,            
          51,    0,                0,            
          50,    0,                0,            
          -1,     189,     188,
          -1,     191,     190,
          -1,     193,     192,
          54,    0,                0,            
          53,    0,                0,            
          -1,     195,     194,
         448,    0,                0,            
         384,    0,                0,            
         320,    0,                0,            
          -1,     197,     196,
          -1,     199,     198,
          60,    0,                0,            
          59,    0,                0,            
          -1,     201,     200,
          -1,     203,     202,
          56,    0,                0,            
          55,    0,                0,            
          -1,     205,     204,
          -1,     207,     206,
          52,    0,                0,            
        2560,    0,                0,            
        2496,    0,                0,            
        2432,    0,                0,            
        2368,    0,                0,            
        2304,    0,                0,            
        2240,    0,                0,            
        2176,    0,                0,            
        2112,    0,                0,            
        2048,    0,                0,            
        1984,    0,                0,            
        1216,    0,                0,            
        1152,    0,                0,            
        1088,    0,                0,            
        1024,    0,                0,            
         960,    0,                0,            
         896,    0,                0,            
         576,    0,                0,            
         512,    0,                0,            
        1728,    0,                0,            
        1664,    0,                0,            
        1600,    0,                0,            
        1536,    0,                0,            
        1472,    0,                0,            
        1408,    0,                0,            
        1344,    0,                0,            
        1280,    0,                0,            
         832,    0,                0,            
         768,    0,                0,            
         704,    0,                0,            
         640,    0,                0, 
    };
    for(i=0;i<208;i++)
    {
        black_tree[i].value = black_tree_temp[i][0];
        black_tree[i].child_zero = black_tree_temp[i][1];
        black_tree[i].child_one = black_tree_temp[i][2];
    }

#else
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"W_TERMI.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"W_TERMI.DAT");
    
    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,1000) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i = 0;i < 64;i ++)
    {
        j = 0;
        while(*currentpointer != '\"') currentpointer ++;
        while(*++currentpointer != '\"')
        {
            *(white_terminating_code + i * 9 + j) = *(currentpointer);
            j ++;
        }
        currentpointer++;
        *(white_terminating_code + i * 9 + j) = '\0';
    }
    
    _lclose(filehandle);
    
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"B_TERMI.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"B_TERMI.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,1000) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i = 0;i < 64;i ++)
    {
        j = 0;
        while(*currentpointer != '\"') currentpointer ++;
        while(*++currentpointer != '\"')
        {
            *(black_terminating_code + i * 13 + j) = *(currentpointer);
            j ++;
        }
        currentpointer++;
        *(black_terminating_code + i * 13 + j) = '\0';
    }
    
    _lclose(filehandle);
    
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"W_MAKEUP.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"W_MAKEUP.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,1000) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i = 0;i < 40;i ++)
    {
        j = 0;
        while(*currentpointer != '\"') currentpointer ++;
        while(*++currentpointer != '\"')
        {
            *(white_make_up_code + i * 13 + j) = *(currentpointer);
            j ++;
        }
        currentpointer++;
        *(white_make_up_code + i * 13 + j) = '\0';
    }
    
    _lclose(filehandle);
    
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"B_MAKEUP.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"B_MAKEUP.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,1000) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i = 0;i < 40;i ++)
    {
        j = 0;
        while(*currentpointer != '\"') currentpointer ++;
        while(*++currentpointer != '\"')
        {
            *(black_make_up_code + i * 14 + j) = *(currentpointer);
            j ++;
        }
        currentpointer++;
        *(black_make_up_code + i * 14 + j) = '\0';
    }
    
    _lclose(filehandle);

    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"TABLE.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"TABLE.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,14500) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i=0;i<256;i++)
    {
        j = 0;
        while(*currentpointer != 0x0d)
        {
            buffer[j] = *currentpointer;
            currentpointer ++;
            j ++;
        }
        
        buffer[j] = '\0';
        currentpointer += 2;
        
        j = 0;
        for(converti = 0;converti < 9;converti ++)
        {
            convertj = 0;
            while(buffer[j++] != ',')
                convertbuffer[convertj++] = buffer[j - 1];
            convertbuffer[convertj] = '\0';
            
            bd.pixel[converti] = atoi(convertbuffer);
            
        }
        
        for(j=0;j<9;j++)    table[i].pixel[j] = bd.pixel[j];
    }
    
    _lclose(filehandle);
    
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"W_TREE.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"W_TREE.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,7200) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i=0;i<208;i++)
    {
        j = 0;
        while(*++currentpointer != 0x0d)
        {
            buffer[j] = *currentpointer;
            j ++;
        }
        buffer[j] = '\0';
        currentpointer += 2;
        
        j = 0;
        for(converti = 0;converti < 3;converti ++)
        {
            convertj = 0;
            while(buffer[j++] != ',')
                convertbuffer[convertj++] = buffer[j - 1];
            convertbuffer[convertj] = '\0';
            
            if(converti == 0)
                nd.value = atoi(convertbuffer);
            else if(converti == 1)
                nd.child_zero = atoi(convertbuffer);
            else
                nd.child_one = atoi(convertbuffer);
        }
        
        white_tree[i].value = nd.value;
        white_tree[i].child_zero = nd.child_zero;
        white_tree[i].child_one  = nd.child_one;
    }
    
    _lclose(filehandle);
    
    if(szLibraryPath[0] != '\0')
    {
        lstrcpy((LPSTR)szFilenameBuffer,(LPCSTR)szLibraryPath);
        lstrcat((LPSTR)szFilenameBuffer,"B_TREE.DAT");
    }
    else
        lstrcpy((LPSTR)szFilenameBuffer,"B_TREE.DAT");

    filehandle = OpenFile((LPCSTR)szFilenameBuffer,(OFSTRUCT*)&of_struct,
                    OF_READ|OF_SHARE_DENY_WRITE);
    if(filehandle == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    if(_lread(filehandle,temppointer,7200) == HFILE_ERROR)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error open file ");
        lstrcat((LPSTR)errormessage,(LPCSTR)szFilenameBuffer);
        GlobalUnlock(static_data_handle);
        GlobalFree(static_data_handle);
        GlobalUnlock(temphandle);
        GlobalFree(temphandle);
        return ;
    }
    
    currentpointer = temppointer;
    
    for(i=0;i<208;i++)
    {
        j = 0;
        while(*++currentpointer != 0x0d)
        {
            buffer[j] = *currentpointer;
            j ++;
        }
        buffer[j] = '\0';
        currentpointer += 2;
        
        j = 0;
        for(converti = 0;converti < 3;converti ++)
        {
            convertj = 0;
            while(buffer[j++] != ',')
                convertbuffer[convertj++] = buffer[j - 1];
            convertbuffer[convertj] = '\0';
            
            if(converti == 0)
                nd.value = atoi(convertbuffer);
            else if(converti == 1)
                nd.child_zero = atoi(convertbuffer);
            else
                nd.child_one = atoi(convertbuffer);
        }
        
        black_tree[i].value = nd.value;
        black_tree[i].child_zero = nd.child_zero;
        black_tree[i].child_one  = nd.child_one;
    }
    
    _lclose(filehandle);

#endif

    GlobalUnlock(temphandle);
    GlobalFree(temphandle);

    return;
}

//  static varable used by Group4
//  begin

char *CTiff::largest_colorless_code;
unsigned char  CTiff::write_one[Pixels_per_byte];
unsigned char  CTiff::write_zero[Pixels_per_byte];

//  end

HANDLE CTiff::grp4decomp(HANDLE hindata,DWORD inbytes,
                int width,int height)
{
    if(errorflag) return (NULL);
    
    unsigned char* indata;
    unsigned char* outdata;
    HANDLE houtdata,temphandle0,temphandle1;
    
    indata = (unsigned char*)GlobalLock(hindata);
    if(indata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        return (NULL);
    }
    if(GlobalSize(hindata) < inbytes)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"input data for G4_DeCom not correct .");
        GlobalUnlock(hindata);
        return (NULL);
    }
    
    int templongvalue;
    
    templongvalue = (width + 7) / 8 * (long)height + sizeof(MYHEAD);
    houtdata = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    if(houtdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        GlobalUnlock(hindata);
        return (NULL);
    }
    outdata = (unsigned char*)GlobalLock(houtdata);
    if(outdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalFree(houtdata);
        return (NULL);
    }
    
    *(outdata + 0) = 'C';
    *(outdata + 1) = 'L';
    templongvalue = 5;
    *((int*)(outdata + 2)) = templongvalue;
    templongvalue = width + (height << 16);
    *((int*)(outdata + 2 + sizeof(int))) = templongvalue;
    MYHEAD *headpointer;
    headpointer = (MYHEAD*)outdata;
    headpointer -> res_unit = resolutionunit;
    headpointer -> h_res0 = h_res0;
    headpointer -> h_res1 = h_res1;
    headpointer -> v_res0 = v_res0;
    headpointer -> v_res1 = v_res1;
    
    outdata += sizeof(MYHEAD);
    
    struct changing_element 
    {
        int color;
        int pixel;
    } a0, a1;               

    int     b1, b2;
    struct decom_parameters 
    {
        int     index;
        int     max_pixel;
        int     *reference_line;
        int     *coding_line;
    };

    struct decompressed_descriptor 
    {
        unsigned char *data;
        int  pixels_per_line;
        int  number_of_lines;
    };

    struct compressed_descriptor 
    {
        unsigned char *data;
        int    pixels_per_line;
        int    number_of_lines;
        long   length_in_bytes;
    };

    struct compressed_descriptor    compressed;
    struct decompressed_descriptor  decompressed;
    int ii,offset;
    int ifeofbflag;
    int mode,run_length,length,total_length;
    int patchpixelnumber;
    
    patchpixelnumber = (width + 7) / 8 * 8 - width;
    
    compressed.pixels_per_line = width;
    compressed.number_of_lines = height;
    compressed.length_in_bytes = inbytes;
    compressed.data = indata;
    decomp_write_init_flag = 1;
    decomp_read_init_flag = 1;
    decompressed.data = outdata;

    struct decom_parameters  sole_parameters;
    struct decom_parameters *params = &sole_parameters;

    params->max_pixel = compressed.pixels_per_line;
    decompressed.pixels_per_line = compressed.pixels_per_line;
    decompressed.number_of_lines = compressed.number_of_lines;

    templongvalue = (params->max_pixel + Extra_positions) * sizeof(int);
    temphandle0 = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    temphandle1 = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    if(temphandle0 == NULL || temphandle1 == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    params->reference_line = (int*)GlobalLock(temphandle0);
    if(params->reference_line == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    params->coding_line = (int*)GlobalLock(temphandle1);
    if(params->coding_line == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalUnlock(temphandle0);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    *(params->reference_line + 0) = Invalid;        
    *(params->reference_line + 1) = params->max_pixel;
    *(params->reference_line + 2) = params->max_pixel;
    *(params->reference_line + 3) = params->max_pixel;
    
    *(params->coding_line) = Invalid;
    params->index = 0;

    input_area = compressed.data;
    output_area = decompressed.data;

    int nTempHeight = 0;
    while(1)
    {
    b1 = 1;
    a0.pixel = 0;
    a0.color = White; 
    ifeofbflag = 0;
    
    do 
    {
        if (read_bit() == 1)     
            mode = V0;
    
        else if (read_bit() == 1) 
        {       
            if (read_bit() == 1)  
                mode = VR1;
            else
                mode = VL1;
        }                   
        else 
        {
            if (read_bit() == 1)  
                mode = H;
            else if (read_bit() == 1)  
                mode = P;
            else if (read_bit() == 1) 
            {
                if (read_bit() == 1)
                    mode = VR2;
                else
                    mode = VL2;
            }
            else 
            {
                if (read_bit() == 1) 
                {
                    if (read_bit() == 1)
                        mode = VR3;
                    else
                        mode = VL3;
                }
                else 
                {
                    for(ii=0;ii<5;ii++)
                        if (read_bit() != 0) 
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,
                                "error decompressing image .");
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalUnlock(temphandle0);
                            GlobalUnlock(temphandle1);
                            GlobalFree(houtdata);
                            GlobalFree(temphandle0);
                            GlobalFree(temphandle1);
                            return (NULL);
                        }
                    
                    if (read_bit() != 1) 
                    {
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,
                            "error decompressing image .");
                        GlobalUnlock(hindata);
                        GlobalUnlock(houtdata);
                        GlobalUnlock(temphandle0);
                        GlobalUnlock(temphandle1);
                        GlobalFree(houtdata);
                        GlobalFree(temphandle0);
                        GlobalFree(temphandle1);
                        return (NULL);
                    }
            
                    for(ii=0;ii<11;ii++)
                        if (read_bit() != 0) 
                        {
                            errorflag = TRUE;
                            lstrcpy((LPSTR)errormessage,
                                "error decompressing image .");
                            GlobalUnlock(hindata);
                            GlobalUnlock(houtdata);
                            GlobalUnlock(temphandle0);
                            GlobalUnlock(temphandle1);
                            GlobalFree(houtdata);
                            GlobalFree(temphandle0);
                            GlobalFree(temphandle1);
                            return (NULL);
                        }
    
                    if (read_bit() != 1) 
                    {
                        errorflag = TRUE;
                        lstrcpy((LPSTR)errormessage,
                            "error decompressing image .");
                        GlobalUnlock(hindata);
                        GlobalUnlock(houtdata);
                        GlobalUnlock(temphandle0);
                        GlobalUnlock(temphandle1);
                        GlobalFree(houtdata);
                        GlobalFree(temphandle0);
                        GlobalFree(temphandle1);
                        return (NULL);
                    }
        
                    mode = EOFB;
                }
            }
        }
    
        switch( mode ) 
        {

            case    V0: 
        
            case    VR1:
        
            case    VL1:
        
            case    VR2:
        
            case    VL2:
        
            case    VR3:
        
            case    VL3:    

                offset = mode;
                a1.pixel = *(params->reference_line + b1) + offset;
                run_length = a1.pixel - a0.pixel;
                write_bits_d(run_length, a0.color);
                
                a0.pixel = a1.pixel;
                a0.color = ! a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;
     
                if ((offset == -1) || (offset == 0)) 
                {
                    if (*(params->reference_line + b1) != params->max_pixel)
                        b1++;
                }
    
                else if ((offset == 1) || (offset == 2)) 
                {
                    b1++;
                    if ( (*(params->reference_line + b1) <= a0.pixel)  && 
                    (*(params->reference_line + b1) != params->max_pixel) ) 
                        b1 += 2;
                }
    
                else if ((offset == -2) || (offset == -3)) 
                {
                    if ( *(params->reference_line + b1 - 1) > a0.pixel ) 
                        b1--;
                    else 
                    { 
                        if(*(params->reference_line + b1) != params->max_pixel)
                            b1++;
                    }
                }   
                 
                else if (offset == 3) 
                {
                    b1++;
                    while ((*(params->reference_line + b1) <= a0.pixel) &&
                    (*(params->reference_line + b1) != params->max_pixel))
                        b1 += 2;
                }
                
                break;

            case    H:      

                total_length = 0;

                do 
                {
                    length = find_run_length_code(a0.color);    
                    total_length += length;
                } while (length > 63);
    
                write_bits_d(total_length, a0.color);

                a0.pixel += total_length;
                a0.color = !a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;

                total_length = 0;
                do 
                {
                    length = find_run_length_code(a0.color);    
                    total_length += length;
                } while (length > 63);

                write_bits_d(total_length, a0.color);
    
                a0.pixel += total_length;
                a0.color = !a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;
    
                while (  (*(params->reference_line + b1) <= a0.pixel)  && 
                ( *(params->reference_line + b1) < params->max_pixel)  )
                    b1 += 2;
        
                break;

            case    P:      

                b2 = b1 + 1;
                run_length = *(params->reference_line + b2) - a0.pixel;
                write_bits_d(run_length, a0.color);
    
                a0.pixel += run_length;
                b1 += 2;

                continue;

            case    EOFB:
            
                ifeofbflag = EOFB;
                break;

            default  :

                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,
                        "error decompressing image .");
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalUnlock(temphandle0);
                    GlobalUnlock(temphandle1);
                    GlobalFree(houtdata);
                    GlobalFree(temphandle0);
                    GlobalFree(temphandle1);
                    return (NULL);
                }
        }
        
        if(ifeofbflag == EOFB) break;
        
    } while(a0.pixel < params->max_pixel);

    write_bits_d(patchpixelnumber,White);
    
    nTempHeight ++;
    if(ifeofbflag == EOFB || nTempHeight >= height) break;

    *(params->coding_line) = Invalid;
    *(params->coding_line + ++params->index) = params->max_pixel;
    *(params->coding_line + ++params->index) = params->max_pixel;
    *(params->coding_line + ++params->index) = params->max_pixel;

    int* temp;
    
    temp = params->reference_line;
    params->reference_line  = params->coding_line;
    params->coding_line = temp;
        
    params->index = 0;
    
    }

    GlobalUnlock(temphandle0);
    GlobalUnlock(temphandle1);
    GlobalFree(temphandle0);
    GlobalFree(temphandle1);
    
    GlobalUnlock(hindata);
    GlobalUnlock(houtdata);
    return (houtdata);
}


void CTiff::write_bits_d(UINT length,UINT color)
{
    static unsigned int      write_on_this_bit = 0;
    static unsigned long     write_on_this_byte = 0;
    unsigned int             i,bytes;

    if(decomp_write_init_flag)
    {
        write_on_this_bit = 0;
        write_on_this_byte = 0;
        decomp_write_init_flag = 0;
    }
    if (color == Black)
    {
        while( (length>0) && (write_on_this_bit != 0) )
        {
            *(output_area + write_on_this_byte) |= write_one[write_on_this_bit];
            length--;
            if (write_on_this_bit == Last_bit_in_a_byte)
            {
                write_on_this_bit = 0;
                write_on_this_byte++;
            }
            else
                write_on_this_bit++;
        }
        
        bytes=(length/8);
        for(i=0;i<bytes;i++)
            *(output_area + write_on_this_byte + i) = (unsigned char)0x00ff;
        write_on_this_byte += bytes;
        length %= Bits_per_byte;
    
        while( length>0 )
        {
            *(output_area + write_on_this_byte) |= write_one[write_on_this_bit];
            length--;
            if (write_on_this_bit == Last_bit_in_a_byte)
            {
                write_on_this_bit = 0;
                write_on_this_byte++;
            }
            else
                write_on_this_bit++;
        }
    }
    else
    {   
        while( (length>0) && (write_on_this_bit != 0) )
        {
            *(output_area + write_on_this_byte) &=write_zero[write_on_this_bit];
            length--;
            if (write_on_this_bit == Last_bit_in_a_byte)
            {
                write_on_this_bit = 0;
                write_on_this_byte++;
            }
            else
                write_on_this_bit++;
        }
    
        bytes=(length/8);
        for(i=0;i<bytes;i++)
            *(output_area + write_on_this_byte + i) = 0;
        write_on_this_byte += bytes;
        length %= Bits_per_byte;
    
        while( length>0 )
        {
            *(output_area + write_on_this_byte) &=write_zero[write_on_this_bit];
            length--;
            if (write_on_this_bit == Last_bit_in_a_byte)
            {
                write_on_this_bit = 0;
                write_on_this_byte++;
            }
            else
                write_on_this_bit++;
        }
    }
}


int CTiff::read_bit(BOOL reset)
{
    static unsigned char read_bit_mask[Pixels_per_byte] = 
    {
        (unsigned char)0x80,
        (unsigned char)0x40,
        (unsigned char)0x20,
        (unsigned char)0x10,
        (unsigned char)0x08,
        (unsigned char)0x04,
        (unsigned char)0x02,
        (unsigned char)0x01,
    };


    int bit;
    static unsigned int read_this_bit  = 0; 
    static unsigned long read_this_byte = 0;
    
    if(decomp_read_init_flag)
    {
        read_this_bit = 0;
        read_this_byte = 0;
        decomp_read_init_flag = 0;
    }
    
    if(reset)
    {
        if(read_this_bit != 0)
        {
            read_this_bit = 0;
            read_this_byte ++;
            l_v_f_r_l = read_this_byte;
        }
        return 0;
    }
    
    bit = *(input_area + read_this_byte) & read_bit_mask[read_this_bit];
    if(read_this_bit == Last_bit_in_a_byte)
    {
       read_this_bit = 0;
       read_this_byte++;
    }
    else
       read_this_bit++;
    
    l_v_f_r_l = read_this_byte;
    return( !(bit == 0) );
}


int CTiff::find_run_length_code(UINT color)
{
    node* node_ptr;
    node* root_ptr;
    
    if(color == White)
        root_ptr = white_tree;
    else
        root_ptr = black_tree;
        
    node_ptr = root_ptr;

    while(node_ptr->value == Invalid)
    {
          if((read_bit()) == 0)
           node_ptr = root_ptr + node_ptr->child_zero;
          else
           node_ptr = root_ptr + node_ptr->child_one;
    }
     
    return(node_ptr->value);
}


HANDLE CTiff::grp3decomp(HANDLE hindata,DWORD inbytes,
                int width,int height)
{
    if(errorflag) return (NULL);
    
    unsigned char* indata;
    unsigned char* outdata;
    HANDLE houtdata,temphandle0,temphandle1;
    
    indata = (unsigned char*)GlobalLock(hindata);
    if(indata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        return (NULL);
    }
    if(GlobalSize(hindata) < inbytes)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"input data for G3_DeCom not correct .");
        GlobalUnlock(hindata);
        return (NULL);
    }
    
    long templongvalue;
    
    templongvalue = (width + 7) / 8 * (long)height + sizeof(MYHEAD);
    houtdata = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    if(houtdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        GlobalUnlock(hindata);
        return (NULL);
    }
    outdata = (unsigned char*)GlobalLock(houtdata);
    if(outdata == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalFree(houtdata);
        return (NULL);
    }
    
    *(outdata + 0) = 'C';
    *(outdata + 1) = 'L';
    MYHEAD *headpointer;
    headpointer = (MYHEAD*)outdata;
    headpointer -> option = 5;
    headpointer -> metrics = width + (height << 16);
    headpointer -> res_unit = resolutionunit;
    headpointer -> h_res0 = h_res0;
    headpointer -> h_res1 = h_res1;
    headpointer -> v_res0 = v_res0;
    headpointer -> v_res1 = v_res1;
    
    outdata += sizeof(MYHEAD);
    
    if(!(T4Options & 0x00000001L))  // G3_1D_decoding
    {
        int g3_n,g3_i,g3_j,g3_k,g3_m;
        long g3_li;
        
        input_area = indata;
        output_area = outdata;
        decomp_write_init_flag = 1;
        decomp_read_init_flag = 1;
        g3_n = (width + 7) / 8;
        
        for(g3_i=0;g3_i<height;g3_i++)
        {
            for(g3_m=0;g3_m<11;g3_m++)
            {
                if(read_bit() == 1)
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,"error decode data .");
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalFree(houtdata);
                    return NULL;
                }
            }
            while(read_bit() == 0);
            
            g3_li = 0;
            g3_m = 0;
        
            do
            {
                g3_k = 0;
                g3_j = 0;
        
                do 
                {
                    g3_j = find_run_length_code(g3_m);  
                    g3_k += g3_j;
                } while (g3_j > 63);
        
                write_bits_d(g3_k, g3_m);
        
                g3_li += g3_k;
                g3_m = !g3_m;
            }while(g3_li < (long)width);
        
            if(g3_n * 8 != width)
            {
                g3_j = g3_n * 8 - width;
                write_bits_d(g3_j,0);
            }
        }
        
        GlobalUnlock(houtdata);
        GlobalUnlock(hindata);
        return (houtdata);
    }
    
    // G3_2D_decoding
                                    
    struct changing_element 
    {
        int color;
        int pixel;
    } a0, a1;               

    int     b1, b2;
    struct decom_parameters 
    {
        int     index;
        int     max_pixel;
        int     *reference_line;
        int     *coding_line;
    };

    struct decompressed_descriptor 
    {
        unsigned char *data;
        int  pixels_per_line;
        int  number_of_lines;
    };

    struct compressed_descriptor 
    {
        unsigned char *data;
        int    pixels_per_line;
        int    number_of_lines;
        long   length_in_bytes;
    };

    struct compressed_descriptor    compressed;
    struct decompressed_descriptor  decompressed;
    int offset,wNumberOfZeroCount;
    int ifeofbflag;
    int mode,run_length,length,total_length;
    int patchpixelnumber;
    int d2d_line,d2d_j,d2d_k,d2d_m,d2d_index;
    long d2d_li;
    
    patchpixelnumber = (width + 7) / 8 * 8 - width;
    
    compressed.pixels_per_line = width;
    compressed.number_of_lines = height;
    compressed.length_in_bytes = inbytes;
    compressed.data = indata;
    decomp_write_init_flag = 1;
    decomp_read_init_flag = 1;
    decompressed.data = outdata;

    struct decom_parameters  sole_parameters;
    struct decom_parameters *params = &sole_parameters;

    params->max_pixel = compressed.pixels_per_line;
    decompressed.pixels_per_line = compressed.pixels_per_line;
    decompressed.number_of_lines = compressed.number_of_lines;

    templongvalue = (params->max_pixel + Extra_positions) * sizeof(int);
    temphandle0 = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    temphandle1 = GlobalAlloc(GMEM_MOVEABLE,templongvalue);
    if(temphandle0 == NULL || temphandle1 == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error allocating memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    params->reference_line = (int*)GlobalLock(temphandle0);
    if(params->reference_line == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    params->coding_line = (int*)GlobalLock(temphandle1);
    if(params->coding_line == NULL)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error locking memory .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalUnlock(temphandle0);
        GlobalFree(houtdata);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return (NULL);
    }
    
    *(params->coding_line) = Invalid;
    params->index = 0;

    input_area = compressed.data;
    output_area = decompressed.data;
    
    wNumberOfZeroCount = 0;
    
    for(d2d_line=0;d2d_line<height;d2d_line++)
    {
    while(read_bit() == 0) wNumberOfZeroCount++;
    if(wNumberOfZeroCount < 11)
    {
        errorflag = TRUE;
        lstrcpy((LPSTR)errormessage,"error decode data .");
        GlobalUnlock(hindata);
        GlobalUnlock(houtdata);
        GlobalFree(houtdata);
        GlobalUnlock(temphandle0);
        GlobalUnlock(temphandle1);
        GlobalFree(temphandle0);
        GlobalFree(temphandle1);
        return NULL;
    }
    
    if(read_bit() == 1)
    {                       //  1d_decoding
        d2d_li = 0;
        d2d_m = 0;
        *(params->reference_line) = Invalid;
        d2d_index = 0;
        
        do
        {
            d2d_k = 0;
            d2d_j = 0;
        
            do 
            {
                d2d_j = find_run_length_code(d2d_m);
                d2d_k += d2d_j;
            } while (d2d_j > 63);
        
            write_bits_d(d2d_k, d2d_m);
        
            d2d_li += d2d_k;
            *(params->reference_line + ++d2d_index) = (int)d2d_li;
            d2d_m = !d2d_m;
        }while(d2d_li < (long)width);
        
        *(params->reference_line + ++d2d_index) = width;
        *(params->reference_line + ++d2d_index) = width;
        *(params->reference_line + ++d2d_index) = width;
        
// code below is for 0_length white_end_run_for_each_1D_line detecting.
// this is for some kind of tiff files.
// Begin:

        wNumberOfZeroCount = 0;
        
        if(d2d_m == White)
        {
            d2d_li = 0;
            
            for(d2d_j=0;d2d_j<8;d2d_j++)
            {
                d2d_li <<= 1;
                d2d_li += read_bit();
            }
            
            if(d2d_li == 0x35)      // 00110101b white_run_with_zero_length
            {
            }                       // if so, do nothing.
            else if(d2d_li == 0)
            {
                wNumberOfZeroCount = 8;
            }
            else if(d2d_line != height - 1)
            {
                errorflag = TRUE;
                lstrcpy((LPSTR)errormessage,
                    "error decompressing image .");
                GlobalUnlock(hindata);
                GlobalUnlock(houtdata);
                GlobalUnlock(temphandle0);
                GlobalUnlock(temphandle1);
                GlobalFree(houtdata);
                GlobalFree(temphandle0);
                GlobalFree(temphandle1);
                return (NULL);
            }
        }
        
// End.

    }
    else                    //  2d_decoding
    {
    b1 = 1;
    a0.pixel = 0;
    a0.color = White; 
    ifeofbflag = 0;

    do 
    {
        if (read_bit() == 1)     
            mode = V0;
    
        else if (read_bit() == 1) 
        {       
            if (read_bit() == 1)  
                mode = VR1;
            else
                mode = VL1;
        }                   
        else 
        {
            if (read_bit() == 1)  
                mode = H;
            else if (read_bit() == 1)  
                mode = P;
            else if (read_bit() == 1) 
            {
                if (read_bit() == 1)
                    mode = VR2;
                else
                    mode = VL2;
            }
            else 
            {
                if (read_bit() == 1) 
                {
                    if (read_bit() == 1)
                        mode = VR3;
                    else
                        mode = VL3;
                }
                else 
                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,
                        "error decompressing image .");
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalUnlock(temphandle0);
                    GlobalUnlock(temphandle1);
                    GlobalFree(houtdata);
                    GlobalFree(temphandle0);
                    GlobalFree(temphandle1);
                    return (NULL);
                }
            }
        }
    
        switch( mode ) 
        {

            case    V0: 
        
            case    VR1:
        
            case    VL1:
        
            case    VR2:
        
            case    VL2:
        
            case    VR3:
        
            case    VL3:    

                offset = mode;
                a1.pixel = *(params->reference_line + b1) + offset;
                run_length = a1.pixel - a0.pixel;
                write_bits_d(run_length, a0.color);
                
                a0.pixel = a1.pixel;
                a0.color = ! a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;
     
                if ((offset == -1) || (offset == 0)) 
                {
                    if (*(params->reference_line + b1) != params->max_pixel)
                        b1++;
                }
    
                else if ((offset == 1) || (offset == 2)) 
                {
                    b1++;
                    if ( (*(params->reference_line + b1) <= a0.pixel)  && 
                    (*(params->reference_line + b1) != params->max_pixel) ) 
                        b1 += 2;
                }
    
                else if ((offset == -2) || (offset == -3)) 
                {
                    if ( *(params->reference_line + b1 - 1) > a0.pixel ) 
                        b1--;
                    else 
                    { 
                        if(*(params->reference_line + b1) != params->max_pixel)
                            b1++;
                    }
                }   
                 
                else if (offset == 3) 
                {
                    b1++;
                    while ((*(params->reference_line + b1) <= a0.pixel) &&
                    (*(params->reference_line + b1) != params->max_pixel))
                        b1 += 2;
                }
                
                break;

            case    H:      

                total_length = 0;

                do 
                {
                    length = find_run_length_code(a0.color);    
                    total_length += length;
                } while (length > 63);
    
                write_bits_d(total_length, a0.color);

                a0.pixel += total_length;
                a0.color = !a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;

                total_length = 0;
                do 
                {
                    length = find_run_length_code(a0.color);    
                    total_length += length;
                } while (length > 63);

                write_bits_d(total_length, a0.color);
    
                a0.pixel += total_length;
                a0.color = !a0.color;
                *(params->coding_line + ++params->index) = a0.pixel;
    
                while (  (*(params->reference_line + b1) <= a0.pixel)  && 
                ( *(params->reference_line + b1) < params->max_pixel)  )
                    b1 += 2;
        
                break;

            case    P:      

                b2 = b1 + 1;
                run_length = *(params->reference_line + b2) - a0.pixel;
                write_bits_d(run_length, a0.color);
    
                a0.pixel += run_length;
                b1 += 2;

                continue;

            default  :

                {
                    errorflag = TRUE;
                    lstrcpy((LPSTR)errormessage,
                        "error decompressing image .");
                    GlobalUnlock(hindata);
                    GlobalUnlock(houtdata);
                    GlobalUnlock(temphandle0);
                    GlobalUnlock(temphandle1);
                    GlobalFree(houtdata);
                    GlobalFree(temphandle0);
                    GlobalFree(temphandle1);
                    return (NULL);
                }
        }
        
    } while(a0.pixel < params->max_pixel);

    *(params->coding_line) = Invalid;
    *(params->coding_line + ++params->index) = params->max_pixel;
    *(params->coding_line + ++params->index) = params->max_pixel;
    *(params->coding_line + ++params->index) = params->max_pixel;

    int* temp;
    
    temp = params->reference_line;
    params->reference_line  = params->coding_line;
    params->coding_line = temp;
        
    params->index = 0;

    wNumberOfZeroCount = 0;
    
    }

    write_bits_d(patchpixelnumber,White);

    }

    GlobalUnlock(temphandle0);
    GlobalUnlock(temphandle1);
    GlobalFree(temphandle0);
    GlobalFree(temphandle1);
    
    GlobalUnlock(hindata);
    GlobalUnlock(houtdata);
    return (houtdata);
}

#endif
