/////////////////////////////////////////////////////////////////////////
// File Name:		DirLine.h
// File Function:	Interface for CDirLine class
//
//				Developed by: Zheng Yefeng
//			(c)copyright to Tsinghua THOCR Lab, 2001
//					All Right Reserved
//////////////////////////////////////////////////////////////////////////

#ifndef __DIRLINE_H__
#define __DIRLINE_H__

#include "ConnTree.h"
#include "ImageObj.h"
#include "math.h"

class CDirLine : public CObject
{
DECLARE_SERIAL(CDirLine)
public :
    CConnTree m_Tree;//Each strip analysis by a CConnTree instance

public :
	int GetConnComps( ConnComp *&pConnComp, int &nConnComp );
	int GetConnComps(CImage &Image, ConnComp *&pConnComp, int &nConnComp );
    CDirLine() ;
    ~CDirLine() ;

///////////////////////////////////////////////////////////////////////////////////
//	Methods to create Directional Single Connected Chain
///////////////////////////////////////////////////////////////////////////////////
    //Extract runlengths
	int		BuildConnTree ( CImage& Img, RECT rRange ) ;
    //Get pixels on a horizontal image row
	int		AquireHorLineData ( BYTE *p, int w, int h, int n, int start, int end, int *buf, int ImgType, int Channel=0, BOOL bUpSideDown = TRUE ) ;
    //Extract column runlength
	int		GetColumnRunLength ( BYTE *p, int w, int h, int column, int start, int end, LineValley *valley, BOOL bUpSideDown ) ;
	//Add connected component to the ouput image
	int		AddCompImage( BYTE *pImg, int wb, int h, CSize offset, int ConnComp );
};

#endif //__DIRLINE_H__