////////////////////////////////////////////////////////////////////////////////////////////////
// File NAME:		ExtractFeature.h
// File Function:	Extract features
//
//				Developed by: Yefeng Zheng
//			   First created: Jan, 2002
//			University of Maryland, College Park
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef __EXTRACT_FEATURE_H__
#define __EXTRACT_FEATURE_H__

#include "ImageObj.h"
#include "img.h"
#include "WordSegment.h"

int	ExtractFeature( CImage &ImgZone, double *Feature );
int	ExtractFeature( CImage &ImgZone, CWordSegment &WordSeg, int nIndex, double *Feature );
int	ExtractWHFeature( CImage &Img, double *Feature );
int ExtractCCFeature( RECT *pConnComp, int *nConnPixels, int nConnComp, double *Feature );
int ExtractProjFeature( CImage &Img, double *Feature );
int	ExtractStrokeComplexityFeature( BYTE *Line, int w, int h, CRect BoundBox, double *HChgFeature, double *VChgFeature, int Dimension );
int	ExtractStraightnessFeature( BYTE  Line[], int w, int h, CRect BoundBox, double HFeature[], double VFeature[], int Dimension );
int	ExtractSlantStraightnessFeature( BYTE  Line[], int w, int h, RECT BoundBox, double LT_RB_Feature[], double RT_LB_Feature[], int Dimension );
int	ExtractContourFeature( BYTE *ImgByte, int nImgWidth, int nImgHeight, double *Feature );
int	BitToByte( BYTE* RawByte, int wb, int w, int h, BYTE *Line, int w2, int h2, CRect &BoundBox );
int	ByteToBit( BYTE* Line, int w, int h, BYTE *RawByte);
int	ExtractTextureFeature( BWIMG img, double *Feature );

#endif //__EXTRACT_FEATURE_H__
