/******************************************************************************
                                                          COPYRIGHT (C) LJ 2000
******************************************************************************/


#ifndef __IMG_H
#define __IMG_H

#ifdef __cplusplus
extern "C"
{
#endif
/*
 * NOTE: 0 for white, 1 for black.
 */

typedef struct{
  int             xsize, ysize;
  int             xres, yres;
  int             rowsize;      /* bytes per row */
  unsigned char * data;         /* null means empty */
} BWIMG;


/* Feature computation*/

int jBWImgFDR (const BWIMG * pImg, double * H, double * V, double * P, double * M,
               int s, int op);

int jBWImgFDC (const BWIMG * pImg, double * pH, double * pV, double * pP, double * pM, int * pS, int s);

int jBWImgFPH (const BWIMG * pImg, double * FPH, int S[], int s, int * ones, int * zeros);

/* Misc */

void jBWImgFree (BWIMG *pImg);
void jBWImgClearNullBits (BWIMG *pImg);
int  jBWImgCopy (const BWIMG *pOrig, BWIMG *pCopy);
int  jBWImgClip (const BWIMG *pOrig, BWIMG *pClip, int l, int t, int r, int b);
int  jBWImgShear (const BWIMG *pOrig, BWIMG *Res, float skew, int stable_y);
int  jBWImg2xDnSmplX (const BWIMG *pOrig, BWIMG *pRes, int op);
int  jBWImg2xDnSmplY (const BWIMG *pOrig, BWIMG *pRes, int op);
int  jBWImgSumAll (const BWIMG *pImg);

#ifdef __cplusplus
}
#endif

#endif /* __IMG_H */
