/* Gabor.cpp
	Make 2_D Gabor transform on the input gray-scale image.
	ȶͼ2-D DFT任Ƶϸ˹ٽIDFT任

  First Created :
	Wang Xuewen, 2001/2/19

 */

#include "stdafx.h"
#include <stdlib.h>
#include <math.h>
#include "Gabor.h"
#include "fft.h"

/**************************************************************************************
CGaborTrans::CGaborTrans()

	CGaborTransĽ

***************************************************************************************/
CGaborTrans::CGaborTrans()
{
	m_nImgSize = -1;
	m_fWaveLen = -1; 
	m_nOrientNum = 0;
}


/**************************************************************************************
CGaborTrans::~CGaborTrans()

	CGaborTrans

***************************************************************************************/
CGaborTrans::~CGaborTrans()
{
	Free();
}

/**************************************************************************************
CGaborTrans::Init (int nImgSize, float fWaveLen, int nOrientNum, float* pOrient, 
			 float delta_x, float delta_y, int & numFreq)
	  
	ʼCGaborTrans
	
	nImgSize	 : һͼС
	fWaveLen	 : 任lamda
	nOrientNum	 : 任Ƕȵĸ
	pOrient		 : 任Ƕָ,Ƕûȱʾ(radian)
	delta_x		 : ˹纯ˮƽϵķ
	delta_y		 : ˹纯ڴֱϵķ
	numFreq		 : 任Ƶֵĸ, óڵ˱,numFreq
					sizeof(float)*numFreqСڴ.ڵGaborTrans()ʱ,ڴָ
					pFreq
					ʼ,򷵻صnumFreqֵΪ0
	
	:			ɹ:true
					ʧ:false
***************************************************************************************/
bool	CGaborTrans::Init (int nImgSize, float fWaveLen, int nOrientNum, float* pOrient, 
			 float delta_x, float delta_y, int & numFreq)
{
	m_nNumFreq = 0; 
	numFreq = 0;

	if (!nImgSize)	{
		return false;
	}
	if (fWaveLen <= 0)	{
		return false;
	}
	if (!nOrientNum || nOrientNum > 20)	{
		return false;
	}
	if (!pOrient)	{
		return false;
	}


	m_nImgSize = nImgSize;
	m_fWaveLen = fWaveLen;
	m_nOrientNum = nOrientNum;

	int i, j;
	for ( i = 0; i < m_nOrientNum; i ++)
		m_fOrient[i] = pOrient[i];

	float* pGabor = (float*)malloc(sizeof(float)*m_nImgSize*m_nImgSize*m_nOrientNum);
	if (!pGabor)	{
		return false;
	}

	m_pGaussian[0] = (int)pGabor;
	for (i = 1; i < m_nOrientNum; i++)	{
		m_pGaussian[i] = m_pGaussian[i-1] + m_nImgSize*m_nImgSize*sizeof(float);
	}
		
	//˹˲
	float angle;
	float* pGaussian;
	int half = m_nImgSize/2;
	float delta_u, delta_v;
	delta_u = (float)(1/(2.0 * pi * delta_x));
	delta_v = (float)(1/(2.0 * pi * delta_y));
	float u1, v1;
	float A = (float)(2*pi*delta_x*delta_y);
	float cos_angle, sin_angle;

	for (int ori = 0; ori < m_nOrientNum; ori ++)	{
		angle = m_fOrient[ori];
		cos_angle = (float)cos(angle);
		sin_angle = (float)sin(angle);

		pGaussian = (float*)m_pGaussian[ori];
		
		int count = 0;
		for ( i = 0; i < m_nImgSize; i ++ )	{
			for ( j = 0; j < m_nImgSize; j ++ )	{

				u1 = (i-half) * cos_angle + (j-half) * sin_angle;
				v1 = (j-half) * cos_angle - (i-half) * sin_angle;

				*pGaussian = (float)( exp(-0.5*(pow((u1-m_fWaveLen)/delta_u, 2)+pow(v1/delta_v, 2)))
					        +exp(-0.5*(pow((u1+m_fWaveLen)/delta_u, 2)+pow(v1/delta_v, 2))) );
				//*pGaussian *= A;
				if (*pGaussian < 1e-6)
					*pGaussian = 0;
				pGaussian ++;
			}
		}
		
		float temp;
		int desi, desj;
		float* pDesRow;
		float* pSrcRow;
		pGaussian = (float*)m_pGaussian[ori];
		for (i = 0; i < m_nImgSize; i ++)	{
			desi = (i+half)%m_nImgSize;
			pSrcRow = pGaussian + i*m_nImgSize;
			pDesRow = pGaussian + desi*m_nImgSize;
			
			for (j=0; j < half; j ++)	{
				desj = (j+half)%m_nImgSize;
				
				temp = *(pDesRow+desj);
				*(pDesRow+desj) = *(pSrcRow+j);
				*(pSrcRow+j) = temp;
			}
		}
	}

//˹纯
#ifdef _DEBUG
/*	char filename[256];
	for (ori = 0; ori < m_nOrientNum; ori ++)	{
		sprintf(filename,"e:\\temp\\gs%d.dat",ori);
		FILE* pFile = fopen(filename, "wb");
		pGaussian = (float*)m_pGaussian[ori];

		fwrite(pGaussian, sizeof(float), m_nImgSize*m_nImgSize, pFile);

		fclose(pFile);

	}
*/
#endif

	//FFT任ʱڴռ
	if (!Preparefft2(m_nImgSize))
		return false;

	m_nNumFreq = numFreq = m_nImgSize * m_nImgSize * m_nOrientNum;

	return true;
}

/**************************************************************************************
CGaborTrans::~CGaborTrans()

	ͷڴռ

***************************************************************************************/
void	CGaborTrans::Free()
{
	if (m_pGaussian[0])	{
		free((float*)m_pGaussian[0]);
		m_pGaussian[0] = NULL;
	}

	Endfft2();

	m_nNumFreq = 0;


}


/**************************************************************************************
bool	CGaborTrans::GaborTrans(unsigned char* pImage, float* pFreqReal, float* pFreqImg)
	
	ͼGabor任

	pImage : ͼݿ,ص㰴-ģʽ
	pFreqReal  : 任ʵ, ɵó.任ֵΪ	....һǶȵı任(-)...,
	pFreqReal  : 任鲿

	   : 任ɹ true
			   ɹ flase
***************************************************************************************/
bool	CGaborTrans::GaborTrans(unsigned char* pImage, float* pFreqReal, float* pFreqImg)
{
	if (!m_nNumFreq)
		return false;
	if (!m_pGaussian[0])
		return false;
	if (!pImage)
		return false;
	if (!pFreqReal || !pFreqReal)
		return false;

	int i;
	int ori;
	float* pTransReal;	float* pTransImg;
	float* pReal;	float* pImg;
	float* pGaussian;
	int len = m_nImgSize * m_nImgSize;

	
	//Ƚ2FFT
	pTransReal = pFreqReal;
	pTransImg  = pFreqImg;
	
	//2FFTʵ鲿
	pReal = pTransReal;
	pImg  = pTransImg;
	for ( i = 0; i < len; i ++)	{
		*pReal = pImage[i];
		*pImg = 0;

		pReal ++; pImg ++;
	}

	fft2(m_nImgSize, pTransReal, pTransImg);
	
	//ƽƵ,ֱƶ
	int half = m_nImgSize/2;
/*	float temp;
	int desi, desj;
	float* pDesRowReal;
	float* pDesRowImg;
	float* pSrcRowReal;
	float* pSrcRowImg;

	for (i = 0; i < m_nImgSize; i ++)	{
		desi = (i+half)%m_nImgSize;
		pSrcRowReal = pTransReal + i*m_nImgSize;
		pSrcRowImg = pTransImg + i*m_nImgSize;
		pDesRowReal = pTransReal + desi*m_nImgSize;
		pDesRowImg = pTransImg + desi*m_nImgSize;
		
		for (j=0; j < half; j ++)	{
			desj = (j+half)%m_nImgSize;
			
			temp = *(pDesRowReal+desj);
			*(pDesRowReal+desj) = *(pSrcRowReal+j);
			*(pSrcRowReal+j) = temp;

			temp = *(pDesRowImg+desj);
			*(pDesRowImg+desj) = *(pSrcRowImg+j);
			*(pSrcRowImg+j) = temp;
		}
	}
*/
	
	//FFT
#ifdef _DEBUG
/*	char filename[256];
	FILE* pFile;

	sprintf(filename,"e:\\temp\\fft0r.dat");
	pFile = fopen(filename, "wb");
	fwrite(pFreqReal, sizeof(float), m_nImgSize*m_nImgSize, pFile);
	fclose(pFile);

	sprintf(filename,"e:\\temp\\fft0i.dat");
	pFile = fopen(filename, "wb");
	fwrite(pFreqImg, sizeof(float), m_nImgSize*m_nImgSize, pFile);
	fclose(pFile);
*/
#endif

	//FFT任ƵǶ
	pTransReal = pFreqReal;
	pTransImg = pFreqImg;
	for (ori = 1; ori < m_nOrientNum; ori ++)	{
		pTransReal += len;
		pTransImg  += len;

		memcpy(pTransReal, pFreqReal, len*sizeof(float));
		memcpy(pTransImg , pFreqImg , len*sizeof(float));
	}

//FFT
#ifdef _DEBUG
/*	pTransReal = pFreqReal;
	pTransImg = pFreqImg;
	for (ori = 0; ori < m_nOrientNum; ori ++)	{

		sprintf(filename,"e:\\temp\\fft%dr.dat", ori+1);
		pFile = fopen(filename, "wb");
		fwrite(pTransReal, sizeof(float), m_nImgSize*m_nImgSize, pFile);
		fclose(pFile);

		sprintf(filename,"e:\\temp\\fft%di.dat", ori+1);
		pFile = fopen(filename, "wb");
		fwrite(pTransImg, sizeof(float), m_nImgSize*m_nImgSize, pFile);
		fclose(pFile);

		pTransReal += len;
		pTransImg  += len;

	}
*/
#endif


	for (ori = 0; ori < m_nOrientNum; ori ++)	{
		
		//˹纯
		pTransReal = pFreqReal + ori * len;
		pTransImg  = pFreqImg  + ori * len;
		
		pReal = pTransReal;
		pImg  = pTransImg;
		pGaussian = (float*)m_pGaussian[ori];
		for ( i = 0; i < len; i ++)	{
			if (*pGaussian == 0)	{
				*pReal = *pImg = 0;
			}	else	{
				*pReal *= *pGaussian;
				*pImg  *= *pGaussian;
			}

			pReal ++;
			pImg ++;
			pGaussian ++;
		}

		//ƽƵ,ֱӾƶ
/*		for (i = 0; i < m_nImgSize; i ++)	{
			desi = (i+half)%m_nImgSize;
			pSrcRowReal = pTransReal + i*m_nImgSize;
			pSrcRowImg = pTransImg + i*m_nImgSize;
			pDesRowReal = pTransReal + desi*m_nImgSize;
			pDesRowImg = pTransImg + desi*m_nImgSize;
			
			for (j=0; j < half; j ++)	{
				desj = (j+half)%m_nImgSize;
				
				temp = *(pDesRowReal+desj);
				*(pDesRowReal+desj) = *(pSrcRowReal+j);
				*(pSrcRowReal+j) = temp;

				temp = *(pDesRowImg+desj);
				*(pDesRowImg+desj) = *(pSrcRowImg+j);
				*(pSrcRowImg+j) = temp;
			}
		}
*/
		//IFFT任		
		ifft2(m_nImgSize, pTransReal, pTransImg);
	}


//Gabor任
#ifdef _DEBUG
/*	pTransReal = pFreqReal;

	for (ori = 0; ori < m_nOrientNum; ori ++)	{

		sprintf(filename,"e:\\temp\\gabor%d.dat", ori+1);
		pFile = fopen(filename, "wb");

		fwrite(pTransReal, sizeof(float),len, pFile);
		
		fclose(pFile);

		pTransReal += len;
	}*/
#endif


	return true;
}
