////////////////////////////////////////////////////////////////////////////////////////////////
// File NAME:		PostProcess.h
// File Function:	MRF based post processing
//
//				Developed by: Zheng Yefeng
//			   First created: June, 2002
//			University of Maryland, College Park
//					All Right Reserved
///////////////////////////////////////////////////////////////////////////////////////////////////

#if !defined __POST_PROCESS_H__
#define __POST_PROCESS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"
#include "define.h"

int GetNearestZones4Print( ZONE *zone, int nZone, int *LeftIndex, int *RightIndex);
int GetNearestZones4Noise( ZONE *zone, int nZone, int **NearIndex );
int GetLeftRightNeighbor( ZONE *zone, int nCurZone, int nZone, int &LeftIndex, int &LeftDist, int &RightIndex, int &RightDist, int TH_Hor );
int GetTopBottomNeighbor( ZONE *zone, int nCurZone, int nZone, int &TopIndex, int &TopDist, int &BottomIndex, int &BottomDist, int TH_Ver );

int AllocateMRFModel( MRF_MODEL &MRFModel );
int LoadMRFModel( MRF_MODEL &stat, FILE *fpMRFModel, int nNeighborType );
int FreeMRFModel( MRF_MODEL &MRFModel );


int InitStatMeasure( MRF_MODEL &stat );
int GetConditionPDF( int nSize, int label, int lable1, int lable2, MRF_MODEL stat, double *cpdf, int *LableCandiate );
int ZoneType2MRFLabel( int nZoneType );
int MRFLabel2ZoneType( int nLabel );
int GetMRFSizeLevel( int nSize );

int AddCandidate( FLIP_CANDIDATE *FlipCandidate, int &nPointer, double nConf, int nZoneType, int nIndex );
int	HCF( ZONE *zone, int nZone, int *LeftIndex, int *RightIndex, int **NearIndex, MRF_MODEL stat );

int GetConfLevel( double nConf );
int GetMRFLabel( ZONE *zone, int nCurZone );
int GetEnergy( ZONE *zone, int nZone, int nCurZone, int *LeftIndex, int *RightIndex, int **NearIndex, MRF_MODEL stat, 	double	*cdf );
BOOL NeedProcess( int nSizeType, int Label, int LabelLeft, int LabelRight, int LabelTop, int LabelBottom );
int RemoveSmallZone( ZONE *zone, int &nZone );
int GetOverlapArea( ZONE zone1, ZONE zone2 );
int	ProcessIsolatedZone( ZONE *zone, int nZone, int *LeftIndex, int *RightIndex, int **NearIndex );
int GetNeighborNum( ZONE *zone, int nCurZone, int nZone, int TH_Ver, int TH_Hor );
int ProcessTooHighZone( ZONE *zone, int nZone );
BOOL NeedProcess( ZONE &zone );
int	PostProcess( ZONE *SgZone, int nSgZone, MRF_MODEL stat );
int SetMRFParamter( int nClassNum );

#endif // !defined(AFX_SEGMENTEVALUATE_H__B0AA2218_D80C_4551_A352_C19409651883__INCLUDED_)
